CR .( SFF370.F)
\ ' ANSI>OEM TO ANSI><OEM 
\ ' OEM>ANSI TO ANSI><OEM 
REQUIRE SEE LIB\EXT\disasm.f 
REQUIRE [IF] ~mak\CompIF.f
WARNING 0! \     isn't unique

C" CELL-"  FIND NIP 0=
[IF] : CELL- 1 CELLS - ; 
[THEN]
C" U>"  FIND NIP 0=
[IF] : U> SWAP U< ; 
[THEN]
C" D-" FIND NIP 0=
[IF]
: D- ( D1 D2  -- FLAG )
      DNEGATE D+ ;
[THEN]
C" D=" FIND NIP 0=
[IF]
: D= ( D1 D2  -- FLAG )
       D- D0= ;
[THEN]

C" \S" FIND NIP 0=
[IF]
: \S            \ comment to end of file
     SOURCE-ID FILE-SIZE DROP
     SOURCE-ID REPOSITION-FILE DROP
     [COMPILE] \ ; IMMEDIATE
[THEN]
S" ~mak\UTILS_.F"                    INCLUDED

S" ~mak\asm\ASM.FRT"                   INCLUDED
(
0x7C0 CONSTANT BOOTSEG            \  BIOS puts the boot sector at address 7C00
0x700 CONSTANT STACKSEG           \  This area should be free for the stack...
0xE00 CONSTANT GDT_ADDRESS
0x7C CONSTANT TEST_ADDR
0x20 CONSTANT  M_PIC                    \ I/O for master PIC
0x21 CONSTANT  M_IMR                    \ I/O for master IMR
0xA0 CONSTANT S_PIC                    \ I/O for slave PIC
0xA1 CONSTANT S_IMR                    \ I/O for slace IMR

0x20 CONSTANT EOI                      \ EOI command

0x11 CONSTANT ICW1                     \ Cascade, Edge triggered
                                        \ ICW2 is vector
                                        \ ICW3 is slave bitmap or number
0x01 CONSTANT ICW4                     \ 8088 mode

)
0x20 CONSTANT M_VEC                    \ Vector for master
0x28 CONSTANT S_VEC                    \ Vector for slave

0x0A CONSTANT OCW3_IRR                 \ Read IRR
0x0B CONSTANT OCW3_ISR                 \ Read ISR

0x600 CONSTANT         IDT_ADDRESS     

: DD" [CHAR] " PARSE 0 DO COUNT C, LOOP DROP ;
: CS-DUP 2DUP ;

C" M_WL" FIND NIP 0=
[IF] : M_WL  CS-DUP POSTPONE WHILE ; IMMEDIATE
[THEN]

0 VALUE V_MAIN
0 VALUE MACROVAR

S" SRC\tc_spfopt.f"                  INCLUDED

TRUE WARNING ! \  

\ ==============================================================
\    -

FORTH-BASE HERE - TO TH_H-

HERE TO PE-HEADER

USE32

STARTCODE

RETURN_STACK:    EQU 00210000H
FORTH_STACK:     EQU 00220000H

        mov     ax, 10h ; flat_data
        mov     ds, ax
        mov     es, ax
        mov     fs, ax
        mov     gs, ax
        mov     ss, ax
        mov     esp, RETURN_STACK
        mov     ebp, FORTH_STACK
        mov     [0B8004H],12345678 
;        JMP $
EndCode

HERE TC-JMP,
HERE TO V_MAIN 
HERE 0x20000  ERASE 

\ ==============================================================
\    ,
\    

S" src\spf_defkern.f"                INCLUDED
CR .( S" src\spf_forthproc.f"              INCLUDED)
S" src\spf_forthproc.f"              INCLUDED_L
S" src\code_words.f"                 INCLUDED

S" src\spf_forthproc_hl.f"           INCLUDED

\ ==============================================================

S" src\386\spf_386_const.f"          INCLUDED

\ ==============================================================
\    (. init)

S" src\spf_except.f"                 INCLUDED

\ ==============================================================
\  -
S" src\int.f"                        INCLUDED
S" src\386\spf_386_conv.f"           INCLUDED
CR .( S" src\spf_con_io.f"                 INCLUDED)
S" src\spf_con_io.f"                 INCLUDED

\ ==============================================================
\  

S" src\spf_print.f"                  INCLUDED

\ ==============================================================

\  -
S" src\386\delay.f"                  INCLUDED
S" src\386\dma.f"                    INCLUDED
S" src\386\fdc.f"                    INCLUDED
S" src\386\spf_386_io.f"             INCLUDED
\ ==============================================================
\  

\ S" src\386\spf_386_memory.f"         INCLUDED

\ ==============================================================
\    -
S" src\compiler\spf_parser.f"        INCLUDED
S" src\compiler\spf_read_source.f"   INCLUDED
\ ==============================================================
\      .
\   .
\    .
\  .

\  -
TRUE TO MACROVAR

S" src\macroopt.f"                   INCLUDED \   
\ S" src\macroopt.f"                   INCLUDED
S" src\compiler\spf_compile.f"       INCLUDED
S" src\compiler\spf_wordlist.f"      INCLUDED
S" src\compiler\spf_find.f"          INCLUDED
S" src\compiler\spf_words.f"         INCLUDED

\ ==============================================================
\   .
\  .
\  .
\  .
\  .
\   .
S" src\compiler\spf_translate.f"     INCLUDED
S" src\compiler\spf_error.f"         INCLUDED
S" src\compiler\spf_defwords.f"      INCLUDED
S" src\compiler\spf_immed_transl.f"  INCLUDED
S" src\compiler\spf_immed_lit.f"     INCLUDED
S" src\compiler\spf_literal.f"       INCLUDED
S" src\compiler\spf_immed_control.f" INCLUDED
S" src\compiler\spf_immed_loop.f"    INCLUDED

\ ==============================================================
\  , startup

CR .( S" src\spf_init.f"              INCLUDED)
S" src\spf_init.f"              INCLUDED
S" src\test.f"              INCLUDED
\ S" src\float\floatkern.f"            INCLUDED
\ S" src\float\floathi.f"              INCLUDED

\ ==============================================================

' INIT V_MAIN - V_MAIN 4 - !

TC-LAST @  ' FORTH-WORDLIST >BODY  @ TH_H- - !
HERE >T ' DP >BODY (  DP)  !
\ TC-WINAPLINK @ ' WINAPLINK >BODY !

\S


' INIT V_MAIN - V_MAIN 4 - !

CR .( =============================================================)
CR .( Done.
CR .( =============================================================)
CR .

\  TSAVE 