(  ,     .
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
)

USER LAST-CFA

: SHEADER ( addr u -- )
  HERE 0 , ( cfa )
  DUP LAST-CFA !
  0 C,     ( flags )
  ROT ROT WARNING @
  IF 2DUP SFIND
     IF DROP 2DUP TYPE ."  isn't unique" CR
     ELSE 2DROP THEN
  THEN
  CURRENT @ +SWORD
  ALIGN
  HERE SWAP ! (  cfa )
;

: HEADER ( "name" -- )
  NextWord SHEADER
;

: CREATED ( addr u -- )
\    c-addr u   ,  .
\      ,  
\  .     
\   name. CREATE       name.
\ name : ( -- a-addr )
\ a-addr -    name.   name 
\     DOES>.
  ALIGN-BYTES @ 1 ALIGN-BYTES !
  ROT ROT SHEADER 4 ALIGN-BYTES !
  HERE 5 + ALIGNED 5 -
  HERE - ALLOT HERE LAST-CFA @ !
  ALIGN-BYTES !
  HERE DOES>A ! (  DOES )
  ['] _CREATE-CODE COMPILE,
;

: CREATE ( "<spaces>name" -- ) \ 94
   NextWord CREATED
;

: (DOES1) \  ,     CREATE ()
  R> DOES>A @ CFL + -
  DOES>A @ 1+ !
;
Code (DOES2)
   SUB  EBP,  4
   MOV DWORD PTR [ EBP ], EAX
   POP  EBX
   POP  EAX
   PUSH EBX
   RET
EndCODE

' (DOES2) (TO) DOES-CODE

: DOES>  \ 94
\ :  .
\ : ( C: clon-sys1 -- colon-sys2 )
\    ,  ,  
\ .       
\       DOES>,   .
\  colon-sys1   colon-sys2.  
\ ,  ,   .
\  : ( -- ) ( R: nest-sys1 -- )
\      name,  
\  name,  .     -
\ ,  nest-sys1.   ,  name
\     CREATE    ,
\  CREATE.
\ : ( i*x -- i*x a-addr ) ( R: -- nest-sys2 )
\      nest-sys2  
\ .     name  .  
\ i*x   name.
\ name : ( i*x -- j*x )
\   ,     ,
\  DOES>,   name.   i*x  j*x
\      name, .
  ['] (DOES1) COMPILE,
  ['] (DOES2) COMPILE,
; IMMEDIATE

: VOCABULARY ( "<spaces>name" -- )
\      name.  name   
\        name.
  WORDLIST DUP
  CREATE
  ,
  LATEST OVER CELL+ ! (     )
  GET-CURRENT SWAP PAR! ( - )
\  FORTH-WORDLIST SWAP CLASS! (  )
  VOC
  ( DOES>     )
  (DOES1) (DOES2) \    DOES>,  
  @ CONTEXT !
;

: VARIABLE ( "<spaces>name" -- ) \ 94
\   .  name,  .
\    name   ,  .
\        .
\ name   "".
\ name : ( -- a-addr )
\ a-addr -   .     
\ 
  CREATE
  0 ,
;
: CONSTANT ( x "<spaces>name" -- ) \ 94
\   .  name,  .
\    name   ,  .
\ name   "".
\ name : ( -- x )
\  x  .
  HEADER
  ['] _CONSTANT-CODE COMPILE, ,
;
: VALUE ( x "<spaces>name" -- ) \ 94 CORE EXT
\   .  name,  .  
\   name   ,  ,   
\   x.
\ name   "".
\ : ( -- x )
\  x  .  x - ,   ,   ,
\     x TO name,    x, 
\   name.
  HEADER
  ['] _CONSTANT-CODE COMPILE, ,
  ['] _TOVALUE-CODE COMPILE,
;
: VECT ( -> )
  (  ,     ,
        xt  TO)
  HEADER
  ['] _VECT-CODE COMPILE, ['] NOOP ,
  ['] _TOVALUE-CODE COMPILE,
;

: ->VARIABLE ( x "<spaces>name" -- ) \ 94
  HEADER
  ['] _CREATE-CODE COMPILE,
  ,
;
: USER ( "<spaces>name" -- ) \ v v 
  HEADER
  ['] _USER-CODE COMPILE,
  USER-HERE ,
  4 USER-ALLOT
;
: USER-CREATE ( "<spaces>name" -- )
  HEADER
  ['] _USER-CODE COMPILE,
  USER-HERE ,
;
: USER-VALUE ( "<spaces>name" -- ) \ 94 CORE EXT
  HEADER
  ['] _USER-VALUE-CODE COMPILE,
  USER-HERE ,
  4 USER-ALLOT
  ['] _TOUSER-VALUE-CODE COMPILE,
;
: ->VECT ( x -> )
  HEADER
  ['] _VECT-CODE COMPILE, ,
  ['] _TOVALUE-CODE COMPILE,
;

CREATE C-SMUDGE 12 C,

: SMUDGE ( -> )
  C-SMUDGE C@
  LAST @ 1+ C@
  C-SMUDGE C!
  LAST @ 1+ C!
;

: HIDE
  12 C-SMUDGE C! SMUDGE
;

: :NONAME ( C: -- colon-sys ) ( S: -- xt ) \ 94 CORE EXT
\    xt,     
\   ,  colon-sys.  
\    .
\   xt   ,  
\   .       
\ xt EXECUTE.
\        ,
\ colon-sys      .
\ : ( i*x -- i*x ) ( R: -- nest-sys )
\      nest-sys   
\ .   i*x   xt.
\ xt : ( i*x -- j*x )
\  ,  xt.   i*x  j*x 
\     xt .
  LAST @ 1+ C@ C-SMUDGE C! SMUDGE
  HERE ]
  HERE TO :-SET
;

: : ( C: "<spaces>name" -- colon-sys ) \ 94
\   .  ,  .
\    ,  "  ".
\       , 
\ colon-sys.   ,  ,  
\ .     , -
\    .     
\       ,    .
\ : ( i*x -- i*x ) ( R: -- nest-sys )
\   nest-sys   .  
\ i*x   .
\  : ( i*x -- j*x )
\   .   i*x  j*x 
\     .
  HEADER ]
  HIDE
  HERE TO :-SET
;

: FIELD  ( offset size "new-name< >" -- offset+size )
      : OVER
        LIT,
       ['] + COMPILE,
       EVEN-EBP  RET,  [COMPILE] [ SMUDGE  \ ;
       +
;  
0 [IF]
: --
  HEADER
  ['] _---CODE COMPILE,
  OVER , +
;
[ELSE]
: -- FIELD ;
[THEN]

: [ELSE]
    1
    BEGIN
      NextWord DUP
      IF  
         2DUP S" [IF]"   COMPARE 0= IF 2DROP 1+                 ELSE 
         2DUP S" [ELSE]" COMPARE 0= IF 2DROP 1- DUP  IF 1+ THEN ELSE 
              S" [THEN]" COMPARE 0= IF       1-                 THEN
                                    THEN  THEN   
      ELSE 2DROP REFILL  AND
      THEN DUP 0=
    UNTIL  DROP ;  IMMEDIATE

: [IF] 0= IF [COMPILE] [ELSE] THEN ;  IMMEDIATE

: [THEN] ;  IMMEDIATE
