(        .
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
    ..
  email:mak@mail.rtc.neva.ru
  http://informer.rtc.neva.ru/
    {812}105-92-03
    {812}552-47-64
)
HEX
VECT FIND

Code SEARCH-WORDLIST ;( c-addr u wid -- 0 | xt 1 | xt -1 ) \ 94 SEARCH
;  ,   c-addr u   , 
; wid.    ,  .
;   ,    xt   (1), 
;   ,    (-1).
       SUB  EBP,   4
       MOV  DWORD PTR [ EBP ], EAX
       PUSH EDI
       MOV ESI, DWORD PTR [ EBP ]                 ;   
       MOV EDX, DWORD PTR [ EBP+4 ]               ;  ()
       MOV EDI, DWORD PTR [ EBP+8 ]               ;    ES:DI
       XOR EBX, EBX
       XOR EAX, EAX
       CLD
       MOV ESI, DWORD PTR [ ESI ]            ;     DS:SI

M1:    SBEGIN  ; LABEL  @@1
         CMP ESI, EBX
         JZ SHORT M2                   ;  
         LODSB
         CMP AL, DL
       SWHILE 0<>
         ADD ESI, EAX       ;    -  
         MOV ESI, DWORD PTR [ ESI ]
       SREPEAT 
       XOR ECX, ECX
       MOV CL, DL
       PUSH EDI                  ;     
       REPZ CMPSB
       POP EDI
       SIF  0<>   ;  JZ SHORT @@5
         ADD ESI, ECX
         MOV ESI, DWORD PTR [ ESI ]
         JMP M1
M2:      ADD EBP,  8
         MOV DWORD PTR [ EBP ], 0        ;   " "
       SELSE
         SUB ESI, EDX
         MOV ECX,  -1            ; ""
         SUB ESI,  6
         MOV AL, BYTE PTR [ ESI+4 ]
         AND AL,  1
         SIF 0<> 
             NEG ECX
         STHEN
         MOV EAX, DWORD PTR [ ESI ]
         ADD EBP,  4
         MOV DWORD PTR [ EBP ], ECX
         MOV DWORD PTR [ EBP+4 ], EAX
       STHEN
       POP EDI
       MOV EAX, DWORD PTR [ EBP ]
       ADD EBP,  4
       RET
EndCode

USER CURRENT          \  wid   
USER-CREATE S-O 10 CELLS TC-USER-ALLOT \  
USER-VALUE CONTEXT    \ CONTEXT @  wid1

: FIND1 ( c-addr -- c-addr 0 | xt 1 | xt -1 ) \ 94 SEARCH
\   CORE FIND :
\    ,     c-addr.
\           ,
\  c-addr  .   ,  xt.
\    ,    (1);
\      (-1).   , ,
\  FIND   ,    ,
\     .
  0
  S-O 1- CONTEXT
  DO
   OVER COUNT I @ SEARCH-WORDLIST
   ?DUP IF 2SWAP 2DROP LEAVE THEN
   I S-O = IF LEAVE THEN
   1 CELLS NEGATE
  +LOOP
;

: SFIND ( c-addr u -- c-addr u 0 | xt 1 | xt -1 ) \ 94 SEARCH
\   CORE FIND :
\    ,     c-addr.
\           ,
\  c-addr  .   ,  xt.
\    ,    (1);
\      (-1).   , ,
\  FIND   ,    ,
\     .
  S-O 1- CONTEXT
  DO
   2DUP I @  SEARCH-WORDLIST
   ?DUP IF 2SWAP 2DROP UNLOOP EXIT THEN
   I S-O = IF LEAVE THEN
   1 CELLS NEGATE
  +LOOP
  0
;

: SET-CURRENT ( wid -- ) \ 94 SEARCH
\     ,  wid.
  CURRENT !
;

: GET-CURRENT ( -- wid ) \ 94 SEARCH
\  wid -   .
  CURRENT @
;

: DEFINITIONS ( -- ) \ 94 SEARCH
\       ,       
\ .        .
\         .
  CONTEXT @ CURRENT !
;

: GET-ORDER ( -- widn ... wid1 n ) \ 94 SEARCH
\        - n   
\ widn ... wid1,    . wid1 -   
\ ,   ,  widn -  ,  
\ .    .
  CONTEXT 1+ S-O DO I @ 1 CELLS +LOOP
  CONTEXT S-O - 1 CELLS / 1+
;
: TSTDO DO I . LOOP ;
: FORTH ( -- ) \ 94 SEARCH EXT
\   ,   widn, ...wid2, wid1 ( wid1 
\  )  widn,... wid2, widFORTH-WORDLIST.
  FORTH-WORDLIST CONTEXT !
;

: ONLY ( -- ) \ 94 SEARCH EXT
\          .
\       FORTH-WORDLIST  SET-ORDER.
  S-O TO CONTEXT
  FORTH
;

: SET-ORDER ( widn ... wid1 n -- ) \ 94 SEARCH
\     ,  widn ... wid1.
\    wid1   ,    widn
\ - .  n  -   .   ,
\         
\ .
\       FORTH-WORDLIST  SET-ORDER.
\     n   8.
  ?DUP IF DUP -1 = IF DROP ONLY EXIT THEN
          DUP 1- CELLS S-O + TO CONTEXT
          0 DO CONTEXT I CELLS - ! LOOP
       ELSE S-O TO CONTEXT  CONTEXT 0! THEN
;


: ALSO ( -- ) \ 94 SEARCH EXT
\   ,   widn, ...wid2, wid1 ( wid1 
\  )  widn,... wid2, wid1, wid1.   
\ ,       .
  GET-ORDER 1+ OVER SWAP SET-ORDER
;
: PREVIOUS ( -- ) \ 94 SEARCH EXT
\   ,   widn, ...wid2, wid1 ( wid1 
\  )  widn,... wid2.   ,
\        PREVIOUS.
  CONTEXT 1 CELLS - S-O MAX TO CONTEXT
;

: VOC-NAME. ( wid -- ) \    ,   
  DUP FORTH-WORDLIST = IF DROP ." FORTH"  EXIT THEN
  DUP CELL+ @ ?DUP IF ID. DROP ELSE ." <NONAME>:" U. THEN
;

: ORDER ( -- ) \ 94 SEARCH EXT
\     ,      
\ .    ,    .
\     .
\ ORDER        
\ .      , 
\  #>.
  GET-ORDER ." Context: "
  0 ?DO ( DUP .) VOC-NAME. SPACE LOOP CR
  ." Current: " GET-CURRENT VOC-NAME. CR
;

: LATEST ( -> NFA )
  CURRENT @ @
;
DECIMAL