
S" lib\include\tools.f"          INCLUDED

0x100000 CONSTANT FORTH-BASE
\ 0x7E00 CONSTANT FORTH-BASE



0 VALUE CREATE-CODE
0 VALUE CONSTANT-CODE
0 VALUE TOVALUE-CODE
0 VALUE VECT-CODE
0 VALUE NOOP-CODE
0 VALUE ---CODE
0 VALUE SLITERAL-CODE
0 VALUE CLITERAL-CODE
0 VALUE USER-CODE
0 VALUE (.")-CODE
0 VALUE USER-VALUE-CODE
0 VALUE TOUSER-VALUE-CODE
' R>  VALUE  DOES-CODE

0 VALUE WINAPI-CODE
0 VALUE WNDPROC-CODE
0 VALUE TC-FORTH-INSTANCE>
0 VALUE TC-<FORTH-INSTANCE
\ 0 VALUE TC-RDROP

0 VALUE DO-OFF
0 VALUE ?DO-OFF

0 VALUE OFF-LOOP
0 VALUE OFF-+LOOP

VARIABLE TC-WINAP
VARIABLE TC-WINAPLINK
VARIABLE TC-USER-OFFS 16 TC-USER-OFFS ! \ 16  

: TC-USER-ALLOT ( n -- )
  TC-USER-OFFS +!
;
: TC-USER-HERE ( -- n )
  TC-USER-OFFS @
;

WARNING 0!
ALSO DISASSEMBLER DEFINITIONS


: INST  ( ADR -- ADR' )
        DUP TO NEXT-INST
        COLS 0x29 <
        IF      DIS-OP
                S-BUF COUNT TYPE
        ELSE    DUP DIS-OP  
                OVER BASE-ADDR - 6  H.R SPACE
                DUP ROT 
                2DUP - DUP>R 0x10 U> ABORT" DECOMPILER ERROR"
                DO I C@ 2 H.N LOOP 
                R> 5 < IF 9 EMIT THEN
                9 EMIT S-BUF COUNT TYPE
        THEN    NEXT-INST C@ 0xE8 =
                IF  NEXT-INST 1+ @+ SWAP +
                    CASE
                    CLITERAL-CODE OF  X". 1-  ENDOF
                    SLITERAL-CODE OF  X". 1-  ENDOF
                    VECT-CODE     OF  VECT. ENDOF
                    CONSTANT-CODE OF  CONS. ENDOF
                    USER-CODE     OF  USER. ENDOF
                    CREATE-CODE   OF  CODE. ENDOF
                    USER-VALUE-CODE OF UVAL. ENDOF
                    ENDCASE
                THEN  ;

ONLY FORTH DEFINITIONS

S" ~mak\listing1.f" INCLUDED

0 VALUE PE-HEADER

0 VALUE  'DUP_V
0 VALUE 'DROP_V

:  'DUP  'DUP_V ;
: 'DROP 'DROP_V ;

WORDLIST CONSTANT TC-WORDLIST

ALSO TC-WORDLIST  CONTEXT ! DEFINITIONS


0 VALUE  TH_H-

: [>T] TH_H- + ;

S" SRC\macroopt.f" INCLUDED
\ S" src\mopt.f"                   INCLUDED

: [>T]  ; IMMEDIATE

: >T     TH_H- + ;

S" ~mak\temps6.f"                     INCLUDED 

: NAME. U. ;

VARIABLE TC-LAST   0  TC-LAST !

: TC-SFIND ( ADR LEN -- ADR FALSE | CFA TRUE)
        2>R TC-LAST @
        BEGIN DUP    \ [NFA]
        WHILE TH_H- - DUP  COUNT  2R@ COMPARE 0=
              IF    NAME> TH_H- - 2R> 2DROP  TRUE EXIT
              THEN  NAME>L @
        REPEAT DROP 2R> DROP  1- FALSE ;

: TC-FINDOUT
   TC-SFIND 0= ABORT" Can't find - TC-FINDOUT"
;

: TC-FIND COUNT TC-SFIND ;

: '
      BL WORD DUP
      TC-FIND
      IF   NIP
      ELSE DROP FIND 0= IF  -321 THROW THEN (  -? )
      THEN
;


HEX
: BAD
  0C7 C, 0C1 C, 00000000 , \  mov     ecx , # 0
  0F7 C, F1  C,            \  div     ecx
; IMMEDIATE

: TC-CALL, ( addr -- )
  \      - 3.0
  ?SET
  SetOP
  0E8 C,              \   CALL
  HERE CELL+ - ,
  HERE TO LAST-HERE
;

: TC-JMP, ( addr -- )
  \      - 3.0
  ?SET
  SetOP
  0E9 C,              \   JMP
  HERE CELL+ - ,
  HERE TO LAST-HERE
;


: MCOMPILE, ( CFA -- )
    CON>LIT 
    IF  MACRO?
      IF     MACRO,
      ELSE   TC-CALL,
      THEN
    THEN
;

: TC-LIT,
  S" DUP" TC-FINDOUT MACRO,
  OPT_INIT
  SetOP 0B8 C,  , OPT  \ MOV EAX, #
  OPT_CLOSE ;

: TC-DLIT, ( D --)
  89 C, 45 C, FC C,        \ mov -4 [ebp], eax
  C7 C, 45 C, F8 C, SWAP , \ mov -8 [ebp], # low
  HERE TO :-SET
  SetOP  B8 C, ,                  \ mov eax, # high
  SetOP  8D C, 6D C, F8 C,        \ lea ebp, -8 [ebp]
  HERE TO LAST-HERE
;

: TC-?BRANCH,
  084 TO J_COD
  OPT_INIT SetOP 0xC00B W,    \ OR EAX, EAX
  OPT? 
  IF BEGIN ?BR-OPT-STEP
     UNTIL
  THEN
\  OPT_CLOSE
  HERE TO :-SET
  EVEN-EBP
  HERE TO LAST-HERE
  'DROP MACRO,
  0F C, J_COD C,   \  JZ
  HERE CELL+ - ,
;

: 'DUP
  S" DUP" TC-FINDOUT >T TC-LIT, ; IMMEDIATE

: 'DROP
  S" DROP" TC-FINDOUT >T TC-LIT, ; IMMEDIATE


: TC-BRANCH, ( ADDR -> ) \   ADDR JMP
  0E9 C,              \   JMP
  HERE CELL+ - ,
;

\ : RET,  0C3 C, ;

: TC-RET, \ 
  0C3 C, ;

DECIMAL

: TC-LITERAL \ 94 CORE
\ :  .
\ : ( x -- )
\    ,  ,   .
\  : ( -- x )
\  x  .
  STATE @ IF TC-LIT, THEN
; IMMEDIATE

: TC-2LITERAL \ 94 DOUBLE
\ :  .
\ : ( x1 x2 -- )
\    ,  ,   .
\  : ( -- x1 x2 )
\    x1 x2  .
  STATE @ IF TC-DLIT, THEN
; IMMEDIATE

: HEX-TC-LITERAL ( T -> ... )
  BASE @ >R HEX
  0 0 ROT COUNT 2- SWAP 2+ SWAP >NUMBER 2DROP D>S [COMPILE] TC-LITERAL
  R> BASE !
;


: TC-?LITERAL ( T -> ... )
  \    
  DUP COUNT 2 MIN S" 0x" COMPARE 0= 
  IF HEX-TC-LITERAL EXIT THEN

  0 0 ROT COUNT
  OVER C@ [CHAR] - = IF 1- SWAP 1+ SWAP TRUE ELSE FALSE THEN >R
  >NUMBER
  DUP 1 > IF -2001 THROW THEN \ ABORT" -?"
  IF C@ [CHAR] . <> IF -2002 THROW THEN \ ABORT" -??"
       R> IF DNEGATE THEN
       [COMPILE] TC-2LITERAL
  ELSE DROP D>S
       R> IF NEGATE THEN
       [COMPILE] TC-LITERAL
  THEN
;

0 VALUE END-LST 
0 VALUE BIG-LST
: LIST
CR  END-LST    BIG-LST ?DO I C@ H. LOOP 
    END-LST TO BIG-LST
       HERE TO END-LST
CR  SOURCE TYPE ;

: TC-INTERPRET
  BEGIN
    BL WORD DUP C@
  WHILE STATE @
     IF   DUP COUNT TC-WORDLIST  SEARCH-WORDLIST 
          DUP -1 = IF 2DROP 0 THEN
          IF    NIP EXECUTE
          ELSE 
          DUP COUNT TEMP-NAMES   SEARCH-WORDLIST
             IF    NIP EXECUTE
             ELSE 
                  TC-FIND
                  IF   MCOMPILE,
                  ELSE TC-?LITERAL
                  THEN
             THEN
          THEN
     ELSE DUP   FIND 
          IF    NIP EXECUTE
          ELSE DROP TC-FIND
               IF   EXECUTE
               ELSE TC-?LITERAL
               THEN
          THEN
     THEN ?STACK
  REPEAT DROP \ LIST
;


\ ' TC-INTERPRET TO INTERPRET 

: TC-INCLUDE-FILE ( i*x fileid -- j*x ) \ 94 FILE
  TIB >R >IN @ >R #TIB @ >R SOURCE-ID >R BLK @ >R CURSTR @ >R
  C/L 2 + ALLOCATE THROW TO TIB  BLK 0!
  TO SOURCE-ID
  CURSTR 0!
  BEGIN
    REFILL
  WHILE
    TC-INTERPRET
  REPEAT
  TIB FREE THROW
  SOURCE-ID CLOSE-FILE THROW
  R> CURSTR !  R> BLK ! R> TO SOURCE-ID R> #TIB ! R> >IN ! R> TO TIB
;
: INCLUDED ( i*x c-addr u -- j*x ) \ 94 FILE
  CURFILE @ >R
  DUP CELL+ ALLOCATE THROW CURFILE !
  2DUP CURFILE @ SWAP 1+ MOVE

  R/O OPEN-FILE-SHARED ?DUP
  IF NIP CURFILE @ FREE DROP R> CURFILE ! THROW THEN
  DUP>R
  ['] TC-INCLUDE-FILE CATCH
  ?DUP IF R> CLOSE-FILE DROP THROW
       ELSE RDROP THEN

  CURFILE @  FREE THROW R> CURFILE !
;

' INCLUDED TO INCLUDED$

: TC-HEADER ( "name" -- )
  HERE 0 , ( cfa )
  0 C,     ( flags )
  BL WORD WARNING @
  IF  DUP TC-FIND NIP
     IF DUP COUNT CR TYPE ."  isn't unique" ( ."   .") CR THEN
  THEN
  HERE
  SWAP  ",
  TC-LAST @ ,
       >T TC-LAST !
  HERE >T    SWAP ! (  cfa )
;

: Code ( -- )
     TC-HEADER  STARTCODE ;

: CREATE
   TC-HEADER  CREATE-CODE TC-CALL, ;

: VARIABLE CREATE 0 , ;

: CONSTANT
   TC-HEADER  CONSTANT-CODE TC-CALL,  , ;

: VALUE
  TC-HEADER  CONSTANT-CODE TC-CALL,   , TOVALUE-CODE TC-CALL, ;

: VECT
  TC-HEADER      VECT-CODE TC-CALL, 0 , TOVALUE-CODE TC-CALL, ;

: ->VECT ( x -> )
  TC-HEADER
  VECT-CODE TC-CALL, >T ,
  TOVALUE-CODE TC-CALL,
;

: USER-CREATE ( "<spaces>name" -- )
  TC-HEADER
  USER-CODE TC-CALL,
  TC-USER-HERE ,
;

: USER ( "<spaces>name" -- )
  USER-CREATE
  4 TC-USER-ALLOT
;
: USER-VALUE ( "<spaces>name" -- ) \ 94 CORE EXT
  TC-HEADER
  USER-VALUE-CODE TC-CALL,
  TC-USER-HERE ,
  4 TC-USER-ALLOT
  TOUSER-VALUE-CODE TC-CALL,
;

: TSAVE (  ADDR LEN -- )
  R/W CREATE-FILE THROW >R
  PE-HEADER HERE OVER - R@ WRITE-FILE THROW
  R> CLOSE-FILE THROW
;

: >INT 0x60 C,                 \ PUSHA
\       0x83 C, 0xED C, 0x7F C, \ SUB EBP, 0x7F  
        0x8D C, 0xAC C, 0x24 C, -200 , \ LEA EBP, [ESP-200]

 ; IMMEDIATE
: INT>
 0xB0 C, 0x20 C,  \ mov al, 0x20
 0xE6 C, 0x20 C,  \ out 20, al
 0x61 C,          \ POPA
 0xCF C,          \ RETI
 ; IMMEDIATE


: DO   \ 94
  ?COMP
  S" NIP" TC-FINDOUT DUP MACRO, MACRO,
  0x68 C, HERE 4 ALLOT
  S" C-DO" TC-FINDOUT MACRO,  
  HERE  DUP TO :-SET 
  3 CELLS  add_depth +!
; IMMEDIATE

: ?DO   \ 94 CORE EXT
  ?COMP
  S" NIP" TC-FINDOUT DUP MACRO, MACRO,
  0xBB C, HERE 4 ALLOT
  S" C-?DO" TC-FINDOUT MACRO,
  HERE  DUP TO :-SET 
  3 CELLS  add_depth +!
; IMMEDIATE

: LOOP   \ 94
  ?COMP 
  0xFF C, 0x04 C, 0x24 C, \ inc dword [esp]
  HERE 2+ - DUP ABS 0x7F <
  IF
    0x71 C, C, \ jno short 
  ELSE
    4 - 0x0F C, 0x81 C, , \ jno near
  THEN
  0x0C24648D , \ lea esp, 0c [esp]
  HERE >T SWAP !
  -3 CELLS  add_depth +!
; IMMEDIATE

: +LOOP    \ 94
  ?COMP
  POSTPONE [ S" ' NIP" EVALUATE ]   MACRO,  
    0x8B240401 ,
    0x810FFC45 ,
\ ADD     [ESP] , EAX
\ MOV     EAX , FC [EBP]
\ JNO 
  HERE CELL+ -  ,
    0x0C24648D , \ lea esp, 0xC [esp]
  HERE >T SWAP !
  -3 CELLS  add_depth +!
; IMMEDIATE

: I   \ 94
  ?COMP S" C-I" TC-FINDOUT MACRO,
; IMMEDIATE


: UNLOOP  \ 94
  ?COMP
  0x0C24648D , \ lea esp, 0c [esp]
; IMMEDIATE

: LEAVE    \ 94
  ?COMP
  0x0824648D , \ lea esp, 8 [esp]
  0xC3 C,  \ ret
; IMMEDIATE

: >R   \ 94
  ?COMP
   CELL  add_depth +!
  S" C->R" TC-FINDOUT MACRO,
  1 CELLS  add_depth +!
 ;   IMMEDIATE

: R>
  ?COMP
   -1 CELLS  add_depth +!
  S" C-R>" TC-FINDOUT MACRO,
  -1 CELLS  add_depth +!
 ;   IMMEDIATE

: RDROP
  ?COMP
   -1 CELLS  add_depth +!
  S" C-RDROP" TC-FINDOUT MACRO,
  -1 CELLS  add_depth +!
 ;   IMMEDIATE

: DUP>R
   CELL  add_depth +!
  OPT_INIT SetOP 0x50 C,  OPT_CLOSE
  1 CELLS  add_depth +!
 ; IMMEDIATE


: TC-SLITERAL ( addr u -- )
          SLITERAL-CODE TC-CALL,
          DUP C,
          HERE SWAP DUP ALLOT MOVE \ 0 C,
;
: TC-CLITERAL ( addr u -- )
          CLITERAL-CODE TC-CALL,
          DUP C,
          HERE SWAP DUP ALLOT MOVE \ 0 C,
;



: RP@   \ 94
  ?COMP
  POSTPONE [ S" ' C-RP@" EVALUATE ] MACRO, ;   IMMEDIATE

: S"
  STATE @
  IF   [CHAR] "  PARSE TC-SLITERAL
  ELSE POSTPONE S"
  THEN
; IMMEDIATE

: C"
  STATE @
  IF   [CHAR] " PARSE TC-CLITERAL
  ELSE POSTPONE C"
  THEN
; IMMEDIATE

: TC->MARK ( -> A )
  HERE DUP TO :-SET
  4 -
;
: TC->RESOLVE1 ( A -> )
  HERE
  OVER - 4 -
  SWAP !
  HERE TO :-SET
;

: TC-<MARK ( -> A )
  HERE DUP TO :-SET
;

: TC->RESOLVE ( A, N -- )
  DUP 1 = IF   DROP TC->RESOLVE1
          ELSE 2 <> ABORT"   "
               TC->RESOLVE1
          THEN
  HERE TO :-SET
;

: MIF  POSTPONE IF ; IMMEDIATE

: UNTIL \ 94
  ?COMP 3 <> IF -2004 THROW THEN \ ABORT" UNTIL  BEGIN !"
  TC-?BRANCH,
; IMMEDIATE

: REPEAT 
\    ,  dest.
  ?COMP
  3 <> IF -2005 THROW THEN \ ABORT" REPEAT  BEGIN !"
  DUP HERE 2+ - DUP
  SHORT?
  IF   0xEB C, C, DROP
  ELSE DROP BRANCH, THEN
  >RESOLVE
; IMMEDIATE

: IF  \ 94
  ?COMP HERE TC-?BRANCH, >MARK 1
; IMMEDIATE

: WHILE \ 94
  ?COMP HERE TC-?BRANCH, >MARK 1
  2SWAP
; IMMEDIATE

: M_WL  CS-DUP POSTPONE WHILE ; IMMEDIATE

: AHEAD  \ 94
  ?COMP HERE
  TC-BRANCH, TC->MARK 1
; IMMEDIATE

: MELSE POSTPONE ELSE ; IMMEDIATE

: ELSE \ 94
  ?COMP HERE TC-BRANCH,
  TC->RESOLVE
  TC->MARK 
   2
; IMMEDIATE


: MTHEN POSTPONE THEN ; IMMEDIATE

: THEN \ 94
  ?COMP
  TC->RESOLVE
  HERE  TO :-SET 
; IMMEDIATE

: BEGIN \ 94
  ?COMP
  TC-<MARK 3
  HERE  TO :-SET 
; IMMEDIATE

\ : M_WL  CS-DUP  [COMPILE] WHILE ; IMMEDIATE

: AGAIN  \ 94 CORE EXT
  ?COMP 3 <> ABORT" AGAIN  BEGIN !"
  TC-BRANCH,
; IMMEDIATE

: ."
  ?COMP POSTPONE C"
  (.")-CODE TC-CALL,
; IMMEDIATE

: [CHAR]  \ 94
  ?COMP
  BL WORD 1+ C@ TC-LIT, ; IMMEDIATE

: [']  ' >T TC-LIT, ; IMMEDIATE

: [COMPILE]  \ 94 CORE EXT
  '  TC-CALL,
; IMMEDIATE

: RECURSE   \ 94
\ :   .
\ : ( -- )
\        .
\   ,  RECURSE   DOES>.
  ?COMP
  LAST @ NAME> TC-CALL,
; IMMEDIATE
: ( POSTPONE ( ; IMMEDIATE
: \ POSTPONE \ ; IMMEDIATE
: [ POSTPONE [ ; IMMEDIATE

: (TO) ' >BODY ! ;
: MTO POSTPONE TO ; IMMEDIATE

: TO
  STATE @
  MIF   BL WORD TC-FIND 0= ABORT"  !"
       9 + TC-CALL,
  MELSE POSTPONE TO
  MTHEN ; IMMEDIATE



: M: : ;

: M; POSTPONE ; ; IMMEDIATE

: MIMMEDIATE IMMEDIATE ;

: LAST>TC  ( -- NFA )
  LAST @
  TC-LAST @ TH_H- - LAST !
;

: EXIT TC-RET, ; IMMEDIATE

: IMMEDIATE
  LAST>TC   IMMEDIATE
  LAST ! ;

: :
  TC-HEADER
  ]
  LAST>TC   HIDE
  LAST !
  HERE  MTO :-SET
  INIT-TEMP-NAMES
  SHERE-TO-TAB
\  0
 ;

M: ; \ MIF -2007 THROW MTHEN \ ABORT"  "
  DEL-TEMP-NAMES PREVIOUS
  add_depth 0!      \    ;)
  EVEN-EBP
  LAST>TC 
  TC-RET, \  0x0C3 C, OPT  \ RET,
  POSTPONE  [  SMUDGE
  LAST !
  SHERE-TO-TAB
  M; MIMMEDIATE

M: FIELD  ( offset size "new-name< >" -- offset+size )
  TC-HEADER 
  0x05 C,  OVER , \ MOV EAX X
  0xC3 C,         \ RET
  +
M;  

\ ' TC-INTERPRET TO INTERPRET 

\S

USE32
Code C-RP@ ;( -- RP )
     LEA  EBP,[ EBP - 4 ] 
     MOV  [ EBP ], EAX
     MOV  EAX,  ESP 
     RET
EndCode

: RP@   ['] C-RP@  MACRO, ;   IMMEDIATE

