BASE @ HEX
0 [IF]
Code PC@ ;( PORT# -- N )
     MOV EDX, EAX
     XOR EAX, EAX
     IN   AL, DX \ $EC C,
     RET
EndCode

Code PC! ;( N PORT# -- )
     MOV EDX, EAX
     MOV EAX, [ EBP ]
     OUT  DX,  AL
     MOV EAX, [ EBP+4 ]
     ADD EBP,  8
     RET
EndCode

VARIABLE PENDING-CHAR
60 CONSTANT KB_DATA \ KEYBOARD SCAN CODE PORT
61 CONSTANT KB_CTL  \ CONTROL BITS FOR KEYBOARD SENSE DATA
80 CONSTANT KB_ERRKEYBOARD   \ TRANSMIT ERROR FLAG
VARIABLE ID_SHIFT
: EKEY?
  KB_DATA PC@ 80 AND
  IF    FALSE  DUP ID_SHIFT !
  ELSE  KB_DATA PC@ 36  =
               OVER 2A  = OR
        IF    TRUE ID_SHIFT ! FALSE
        ELSE  TRUE
        THEN
  THEN
;

: EKEY
  BEGIN EKEY? 0= UNTIL
  BEGIN EKEY? UNTIL
  KB_DATA PC@ 7F AND  ID_SHIFT @ 100 AND OR
;

\ : KB-TEST BEGIN  KB_DATA PC@ DUP U. 1 = FFFFF 0 DO LOOP UNTIL ;

: _KEY? ( -- flag ) \ 94 FACILITY
\   ,  "".  "".  
\   ,     .
\      KEY.
\    KEY?   "",  
\ KEY?   KEY  EKEY   ""  
\  .
  EKEY?
;

VECT KEY?  ' _KEY? >T  TO KEY?

CREATE SH_1... DD" !@#$%^&*()_+" 8 C,
CREATE SH_Q... 9 C, DD" QWERTYUIOP{]" 0D C,
CREATE SH_A... DD" ASDFGHJKL:" CHAR " C,
CREATE SH_Z... CHAR \ C, DD" ZXCVBNM<>?"  1E C, CHAR * C, 17 C, BL C, 


CREATE 1... DD" 1234567890-=" 8 C,
CREATE Q... 9 C, DD" QWERTYUIOP[]" 0D C,
CREATE A... DD" ASDFGHJKL;'"
CREATE Z... CHAR \ C, DD" ZXCVBNM,./"  1E C, CHAR * C, 17 C, BL C, 
 FF C,  FF C, FF C, FF C, FF C, 
 FF C,  FF C, FF C, FF C, FF C,

 FF C,  FF C, FF C,
 CHAR 7 C,  CHAR 8 C, CHAR 9 C, CHAR - C,
 CHAR 4 C,  CHAR 5 C, CHAR 6 C, CHAR + C,
 CHAR 1 C,  CHAR 2 C, CHAR 3 C,

: EKEY>CHAR
  DUP   2  U< IF DROP  1B              ELSE
  DUP 0F  U< IF    2 -    1... + C@    ELSE
  DUP 1E  U< IF  0F -    Q... + C@    ELSE
  DUP 2B  U< IF  1E -    A... + C@    ELSE
  DUP 100 U< IF  2B -    Z... + C@    ELSE
  DUP 102 U< IF DROP  1B              ELSE
  DUP 10F U< IF 102 - SH_1... + C@    ELSE
  DUP 11E U< IF 10F - SH_Q... + C@    ELSE
  DUP 12B U< IF 11E - SH_A... + C@    ELSE
                12B - SH_Z... + C@
             THEN THEN THEN THEN THEN  THEN THEN THEN THEN
;

: _KEY ( -- char ) \ 94
\    char.  ,  
\ ,     .
\      . ,   KEY,
\    .
\ ,     ,
\   .
  EKEY EKEY>CHAR
;

VECT KEY  ' _KEY >T  (TO) KEY

CREATE LT 0A0D , \ line terminator
CREATE LTL 2 ,   \ line terminator length

: DOS-LINES ( -- )
  0A0D LT ! 2 LTL !
;
: UNIX-LINES ( -- )
  0A0A LT ! 1 LTL !
;

B8000 VALUE VIDBUF

50 2* 19 *  VALUE VIDBUF-SIZE
' VIDBUF >BODY @
' VIDBUF-SIZE >BODY @ + VALUE VIDBUF-END

20 VALUE BL ( -- char ) \ 94
\ char -   "".

VARIABLE 2CURSOR
VARIABLE ATTRIB

: PAGE-UP  VIDBUF 50 2* + VIDBUF VIDBUF-SIZE CMOVE ;

: 0A-EMIT   50 2*  2CURSOR +!  
  2CURSOR @ VIDBUF-END U< 0=
  IF  PAGE-UP  -50 2* 2CURSOR +!
  THEN
;

: 0D-EMIT  2CURSOR @ VIDBUF - 50 2* / 50 2* * VIDBUF + 2CURSOR !
;

: EMIT
   DUP 0D =     IF DROP 0D-EMIT  LTL @ 2 <> 
                     IF 0A-EMIT  
                     THEN         ELSE
   DUP 0A  XOR
   LTL @ 2 XOR OR 0= IF DROP 0A-EMIT  ELSE
 2CURSOR @ VIDBUF-END U< 0=
     IF -50 2* 2CURSOR +! 0A-EMIT 0D-EMIT THEN
   ATTRIB @ + 2CURSOR @ W! 2 2CURSOR +!
                 THEN  THEN
;
[THEN]

: PAGE BL ATTRIB @ + VIDBUF !
  VIDBUF VIDBUF 2 + VIDBUF-SIZE CMOVE
  VIDBUF 2CURSOR ! ;


\ : EMIT   ATTRIB @ + 2CURSOR @ W! 2 2CURSOR +! ;

: MAIN
  300  ATTRIB !  PAGE 
  PAGE
  BEGIN KEY EMIT  AGAIN ;


BASE !

