HEX

Code DISABLE
    CLI
    RET
EndCode

Code ENABLE
    STI
    RET
EndCode

Code INTC
    INT 0CH
    RET
EndCode

Code INT23
    INT 23H
    RET
EndCode
(
Code SIDT
    SIDT [ EAX ]
    MOV     EAX,  DWORD PTR [ EBP ]
    ADD     EBP,  4
    RET
EndCode
)
Code DS
     SUB     EBP,  4
     MOV     DWORD PTR [ EBP ],  EAX
     XOR     EAX, EAX
     MOV      AX, DS 
     RET
EndCode

Code CS
     SUB     EBP,  4
     MOV     DWORD PTR [ EBP ],  EAX
     XOR     EAX, EAX
     MOV      AX, CS 
     RET
EndCode

Code PC@ ;( PORT# -- N )
     MOV EDX, EAX
     XOR EAX, EAX
     IN   AL,  DX ; $EC C,
     RET
EndCode

Code PC! ;( N PORT# -- )
     MOV EDX,  EAX
     MOV EAX, [ EBP ]
     OUT  DX, AL
     MOV EAX, [ EBP + 4 ]
     ADD EBP,  8
     RET
EndCode

Code  ZZZZ
;        , 
;   CR0,        
; . ..      64.

FOR     EA C, HERE 6 + >T ,  08 W,  \  JMP     dword 8:pmode
     MOV EBX, 12345678H
     MOV [ 0B8111H ], EBX
     RET
EndCode

Code BIOS13 ;( C -- )
;       MOV EBX, EAX
;       MOV EAX, 0
;       MOV CS,  AX
       PUSH EAX
       CLI
FOR       0F C, 20 C, C0 C,  \             MOV     EAX  CR0
       DEC     EAX
FOR       0F C, 22 C, C0 C,  \      MOV     CR0  EAX
FOR       EA C, HERE 4 + >T W,  0 W,  \  JMP     dword 8:pmode
EndCode
USE16
STARTCODE

;  MOV AX,  B800
;       MOV DS, AX
;       MOV BX, 5678H
;       MOV [ 111H ], BX

FOR       0F C, 20 C, C0 C,  \             MOV     AX  CR0
       INC     AX
FOR       0F C, 22 C, C0 C,  \      MOV     CR0  AX

;       MOV AX, 10H
;       MOV DS, AX

FOR     66 C,  EA C, HERE 6 + >T ,  08 W,  \  JMP     dword 8:pmode

        STI
EndCode
USE32  
STARTCODE

 POP EAX
;  MOV     EAX,  DWORD PTR [ EBP ]
;       ADD     EBP,  4
       RET
EndCode


DECIMAL

