(    .
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
)

USER S0   \    
USER R0   \    
USER WARNING
USER STATE ( -- a-addr ) \ 94
     \ a-addr -  ,   " ".
     \ STATE ""   ,  "".
     \  STATE    :
     \ : ; [ ] ABORT QUIT :NONAME
USER BLK
USER CURFILE

VECT OK.
VECT <MAIN>
VECT ?LITERAL
VECT ?SLITERAL

: DEPTH ( -- +n ) \ 94
\ +n -   ,     
\      +n.
  SP@ S0 @ - NEGATE 4 U/
;
: ?STACK ( -> ) \   " ",     
  SP@ S0 @ SWAP U< IF S0 @ SP! -4 THROW THEN
;
: ?COMP ( -> )
  STATE @ 0= IF -312 THROW THEN (     )
;

: WORD ( char "<chars>ccc<char>" -- c-addr ) \ 94
\   .  , 
\  char.
\   ,    
\      .
\ c-addr -   ,   
\     .
\        ,
\     .
\     ,     .
\      .
  DUP SKIP PARSE
  DUP HERE C! HERE 1+ SWAP CMOVE
  BL HERE COUNT + !
  HERE
;

: ' ( "<spaces>name" -- xt ) \ 94
\   .  name,  .  name 
\   xt,    name.   , 
\  name  .
\     ' name EXECUTE    name.
  BL WORD FIND 0= IF -321 THROW THEN (  -? )
;

: CHAR ( "<spaces>name" -- char ) \ 94
\   .  ,  .
\       .
  BL WORD 1+ C@
;


: INTERPRET_ ( -> ) \   
  BEGIN
    NextWord DUP
  WHILE
    SFIND ?DUP
    IF
         STATE @ =
         IF COMPILE, ELSE EXECUTE THEN
    ELSE  ?SLITERAL
    THEN
    ?STACK
  REPEAT 2DROP
;

VARIABLE   &INTERPRET

' INTERPRET_ >T ' &INTERPRET >BODY !

: INTERPRET &INTERPRET @ EXECUTE ;

: OK.1
  STATE @ 0=
  IF ."  Ok" DEPTH 70 UMIN 
     0 ?DO [CHAR] . EMIT LOOP CR 
  THEN
;

: [   \ 94 CORE
\ :  .
\ :   ,  .
\ : ( -- )
\   . [   .
  STATE 0!
; IMMEDIATE

: ] ( -- ) \ 94 CORE
\   .
  TRUE STATE !
;

: QUIT ( -- ) ( R: i*x ) \ CORE 94
\   ,    SOURCE-ID.
\       .
\   .  :
\ -        ,  >IN
\    .
\ -      , 
\       ,   ,
\      .

\ R0 @ RP! (   ,   "['] QUIT CATCH" )
  0 TO SOURCE-ID
  [COMPILE] [
  <MAIN>
;

: MAIN1 ( -- )
  BEGIN
    REFILL
  WHILE
    INTERPRET OK.
  REPEAT
;

: EVALUATE ( i*x c-addr u -- j*x ) \ 94
\     .
\  -1  SOURCE-ID.  ,  c-addr u,
\     ,  >IN  0
\  .      - 
\    .
\       EVALUATE .
  SOURCE-ID >R TIB >R #TIB @ >R >IN @ >R
  -1 TO SOURCE-ID
  #TIB ! TO TIB >IN 0!
  INTERPRET
  R> >IN ! R> #TIB ! R> TO TIB R> TO SOURCE-ID
;

: COM-INCLUDE
  COM-PORT PC@ DROP
  >IN      @ >R
  SOURCE-ID  >R
  RP@   #TIB @ CELL+  - RP!
  TIB  RP@ CELL+ #TIB @ CMOVE
  #TIB  @ >R   -1 TO SOURCE-ID

  CR ." PRESS 'Q' FOR EXIT"
  BEGIN    REFILL
  WHILE    INTERPRET
  REPEAT

  R> #TIB !
  RP@ CELL+ TIB   #TIB @ CMOVE
  RP@  #TIB @ CELL+  + RP!
  R> TO SOURCE-ID
  R> >IN ! 
;

: COM1-INCLUDE
  COM1-INIT   COM-INCLUDE ;

: COM2-INCLUDE
  COM2-INIT   COM-INCLUDE ;

: _QUIT
  BEGIN    REFILL
  WHILE    INTERPRET
  REPEAT ;

