(      WORDLIST.
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
    ..
  email:mak@mail.rtc.neva.ru
  http://informer.rtc.neva.ru/
    {812}105-92-03
    {812}552-47-64
)
HEX
VARIABLE VOC-LIST \  

VARIABLE LAST \     
              \   
              \    LATEST,  
              \     CURRENT

1 CONSTANT &IMMEDIATE \     IMMEDIATE
2 CONSTANT &VOC

HERE >T ' VOC-LIST >BODY !
0 ,                   \  VOC-LIST
HERE >T 0 ,              \    
0 ,                   \ 
0 ,                   \ 
(  ,    WORDLIST,  =0 )
VALUE FORTH-WORDLIST  ( -- wid ) \ 94 SEARCH
\  wid -   ,    
\ ,  .      
\      .
: >BODY ( xt -- a-addr ) \ 94
\ a-addr -   ,  xt.
\   ,  xt   ,
\   CREATE.
(  1+ @    2.5 )
  5 +
;

: +WORD ( A1, A2 -> ) \     ,
         \     A1,  , 
         \  A2.       
         \    ALLOT.    
         \  A2     , 
         \      .
         \ : C" SP-FORTH" CONTEXT @ +WORD
  HERE LAST !
  HERE ROT ", SWAP DUP @ , !
;

: +SWORD ( addr u wid -> ) \     ,
         \   addr u,  ,  wid.
         \       
         \    ALLOT.
  HERE LAST !
  HERE 2SWAP S", SWAP DUP @ , !
;

: WORDLIST ( -- wid ) \ 94 SEARCH
\     ,    wid.
\          
\         .
\       8     
\     .
  HERE VOC-LIST @ , VOC-LIST !
  HERE 0 , \        
       0 , \        
       0 , \ wid -
       0 , \   = wid ,   
;

: CLASS! ( cls wid -- ) CELL+ CELL+ CELL+ ! ;
: CLASS@ ( wid -- cls ) CELL+ CELL+ CELL+ @ ;
: PAR!   ( Pwid wid -- ) CELL+ CELL+ ! ;
: PAR@   ( wid -- Pwid ) CELL+ CELL+ @ ;

\ -5 -- cfa
\ -1 -- flags
\  0 -- NFA
\  1 -- name
\  n -- LFA

Code NAME> ;( NFA -> CFA )
     MOV EAX, DWORD PTR [ EAX-5 ]
     RET
EndCode

Code NAME>C ;( NFA -> 'CFA )
     SUB EAX,  5
     RET
EndCode

Code NAME>F ;( NFA -> FFA )
     DEC EAX
     RET
EndCode

Code NAME>L ;( NFA -> LFA )
     MOVZX EBX, BYTE PTR [ EAX ]
     ADD EAX, EBX
     INC EAX
     RET
EndCode

Code CDR ;( NFA1 -> NFA2 )
     OR EAX, EAX
     SIF 0<>
       XOR EBX, EBX
       MOV BL, BYTE PTR [ EAX ]
       MOV EAX, [EAX+EBX+1]
     STHEN
     RET
EndCode

: ID. ( NFA[E] -> )
  COUNT TYPE
;

: ?IMMEDIATE ( NFA -> F )
  NAME>F C@ &IMMEDIATE AND
;

: ?VOC ( NFA -> F )
  NAME>F C@ &VOC AND
;

: IMMEDIATE ( -- ) \ 94
\      .
\   ,   
\   .
  LAST @ NAME>F DUP C@ &IMMEDIATE OR SWAP C!
;

: VOC ( -- )
\      "".
  LAST @ NAME>F DUP C@ &VOC OR SWAP C!
;

\ ==============================================
\  -       

USER WBW-NFA
USER WBW-OFFS

: WordByAddrWl ( addr wid -- nfa offs )
  -1 1 RSHIFT WBW-OFFS !
  WBW-NFA 0!
  @
  BEGIN
    DUP
  WHILE
    2DUP - DUP 0 > 
        IF WBW-OFFS @ OVER > 
           IF WBW-OFFS ! DUP WBW-NFA !
           ELSE DROP THEN
        ELSE DROP THEN
    CDR
  REPEAT 2DROP
  WBW-NFA @ WBW-OFFS @
;

USER WB-NFA
USER WB-OFFS

: WordByAddr ( addr -- c-addr u )
  \  ,     
  HERE OVER >
  IF 
     -1 1 RSHIFT WB-OFFS !
     WB-NFA 0!
     VOC-LIST @
     BEGIN
       DUP
     WHILE
       2DUP ( addr voc addr voc )
       CELL+ WordByAddrWl
             WB-OFFS @ OVER >
             IF WB-OFFS ! WB-NFA !
             ELSE 2DROP THEN
       @
     REPEAT 2DROP
     WB-NFA @ ?DUP IF COUNT ELSE S" <not found>" THEN
  ELSE DROP S" <not in the image>" THEN
;
DECIMAL