(  -.)

VECT KEY?
VECT EMIT 
VECT TYPE 
VECT CR 
VECT KEY 

BASE @ HEX

CREATE LT 0A0D , \ line terminator
CREATE LTL 2 ,   \ line terminator length

: DOS-LINES ( -- )
  0A0D LT ! 2 LTL !
;
: UNIX-LINES ( -- )
  0A0A LT ! 1 LTL !
;

B8000 VALUE VIDBUF

50 2* 19 *  VALUE VIDBUF-SIZE

: (HARD-AT-XY?) ( -- N )
   0x0F   0x3D4 PC!
          0x3D5 PC@
   0x0E   0x3D4 PC!
          0x3D5 PC@
  8 LSHIFT + ;

: HARD-AT-XY? ( -- X Y )
  (HARD-AT-XY?) 0x50 /MOD  ;

: (HARD-AT-XY) ( N -- )
  0x100 /MOD
   0x0E   0x3D4 PC!
          0x3D5 PC!
   0x0F   0x3D4 PC!
          0x3D5 PC! ;

Code  CRT* 
  LEA EAX, [ EAX*4 + EAX ]  ; 5 *
  ADD EAX, EAX              ; 2*
  LEA EAX, [ EAX*8 ]        ; 8 *
  RET
EndCode

Code 2CRT*
  LEA EAX, [ EAX*4 + EAX ]  ; 5 *
  LEA EAX, [ EAX*4 ]
  LEA EAX, [ EAX*8 ]
  RET
EndCode

: HARD-AT-XY ( X Y -- )
   CRT* +  (HARD-AT-XY) ;


VARIABLE 2CURSOR
VARIABLE ATTRIB

: AT-XY  ( X Y -- )
  CRT* + DUP (HARD-AT-XY) 2* 2CURSOR ! ;

: AT-XY?  ( X Y -- )
  2CURSOR @ 2/ 0x50 /MOD ;

:   VIDBUF-END VIDBUF VIDBUF-SIZE + ;

: COLOR! ( N N1 -- )
 4 LSHIFT + 8 LSHIFT  ATTRIB ! ;
: PAGE-UP  
           VIDBUF VIDBUF 50 2* - VIDBUF-SIZE QCMOVE   \  
           BL ATTRIB @ +  VIDBUF-END 2- W!            \ 
           VIDBUF-END 50 1- 2* -                     \  
           VIDBUF-END 50 2* -                        \ 
                      50 1- 2*  CMOVE> ;

: 0A-EMIT       50 2* 2CURSOR +!
  2CURSOR @ VIDBUF-SIZE U< 0=
  IF  PAGE-UP  -50 2* 2CURSOR +!
  THEN ;

: 0D-EMIT  2CURSOR @ 50 2* /  2CRT* 2CURSOR ! ;

: TAB      ( -- )
           BEGIN BL EMIT 2CURSOR @ 8 2* MOD 0=
           UNTIL ;

: _EMIT ( x -- ) \ 94
\  x -  ,    .
\ ,   ,   .

   DUP 0D =      IF DROP 0D-EMIT  LTL @ 2 <>
                     IF 0A-EMIT
                     THEN               ELSE
   DUP 0A =
   LTL @ 2 = AND IF DROP 0A-EMIT        ELSE

   DUP 08 =      IF  DROP -2 2CURSOR +! ELSE
   DUP 09 =      IF  DROP TAB           ELSE

 2CURSOR @ VIDBUF-SIZE U< 0=
     IF  -0A0 2CURSOR +! PAGE-UP      THEN

      ATTRIB @ + VIDBUF 2CURSOR @ + W! 2 2CURSOR +!

                 THEN  THEN  THEN  THEN
;


: #H.>
 0x10 /MOD SWAP DUP 0xA < IF [CHAR] 0 + ELSE 0x37 + THEN ;

: HH.  
 #H.> >R #H.> >R #H.> >R #H.> >R
 #H.> >R #H.> >R #H.> >R #H.> >R  DROP
 R> _EMIT R> _EMIT R> _EMIT R> _EMIT
 R> _EMIT R> _EMIT R> _EMIT R> _EMIT ;

' _EMIT >T (TO) EMIT


: _TYPE ( c-addr u -- ) \ 94
\  u>0 -   ,  c-addr  u.
\ ,   ,   .
  ANSI><OEM
  0 ?DO COUNT EMIT LOOP DROP ;

' _TYPE >T (TO) TYPE

: (.") ( T -> )
  COUNT TYPE
;
' (.") TO (.")-CODE

: _CR ( -- ) \ 94 \  .
    LT LTL @ TYPE ;

' _CR >T (TO) CR

: PAGE BL ATTRIB @ + VIDBUF !
  VIDBUF VIDBUF 2 + VIDBUF-SIZE CMOVE
  2CURSOR 0! ;

VARIABLE PENDING-CHAR
60 CONSTANT KB_DATA \ KEYBOARD SCAN CODE PORT
61 CONSTANT KB_CTL  \ CONTROL BITS FOR KEYBOARD SENSE DATA
80 CONSTANT KB_ERRKEYBOARD   \ TRANSMIT ERROR FLAG
VARIABLE KB_ATR
\ VARIABLE ID_SHIFT
\ VARIABLE ID_CTRL
\ VARIABLE ID_ALT
0x100  CONSTANT SHIFT_M
0x200  CONSTANT CTRL_M
0x400  CONSTANT ALT_M

: SHIFT+ SHIFT_M OR ;
:  CTRL+  CTRL_M OR ;
:   ALT+   ALT_M OR ;

: SHIFT- SHIFT_M INVERT AND ;
:  CTRL-  CTRL_M INVERT AND ;
:   ALT-   ALT_M INVERT AND ;

VARIABLE ID_E0
1 06 LSHIFT CONSTANT KBDBUF-SIZE
KBDBUF-SIZE 1- CONSTANT KBDBUF-MASKA
\ CREATE KBDBUF KBDBUF-SIZE ALLOT

0 VALUE  KBDBUF
VARIABLE KBDBUFIN

VARIABLE KBDBUFOUT

: KBD-CNT       ( -- count )  \  get how many bytes are in the buffer
     KBDBUFIN @  KBDBUFOUT @ -  2-  KBDBUF-MASKA AND  ;

: KBD-PUT       ( Wchar -- )   \  get a character from the buffer
     KBDBUFIN  @  KBDBUF-MASKA  AND
     KBDBUF  +   W!     \ put the byte
     02  KBDBUFIN   +!         \ increment the pointer
;

: KBD-GET  ( -- Wchar )   \  get a character from the buffer
      02 KBDBUFOUT +!             \ and increment the pointer
      KBDBUFOUT @ KBDBUF-MASKA AND
      KBDBUF +   W@           \ get the byte
;

: EKEY? ( -- FLAG )  KBD-CNT 0<> ;

: EKEY ( -- u ) \ 94 FACILITY EXT
   2CURSOR @  2/ (HARD-AT-XY)
  BEGIN  KBD-CNT UNTIL KBD-GET ;

: EKEY_ ( -- ) \ 94 FACILITY EXT
  BEGIN  KBD-CNT UNTIL ;

CREATE SH_1... DD" !@#$%^&*()_+" 8 C,
CREATE SH_Q... 9 C, DD" qwertyuiop{}" 0D C,
CREATE SH_A... DD" asdfghjkl:" CHAR " C,
CREATE SH_Z... CHAR \ C, DD" zxcvbnm<>?"  1E C, CHAR * C, 17 C, BL C,


CREATE 1... DD" 1234567890-=" 8 C,
CREATE Q... 9 C, DD" QWERTYUIOP[]" 0D C,
CREATE A... DD" ASDFGHJKL;'"
CREATE Z... CHAR \ C, DD" ZXCVBNM,./"  1E C, CHAR * C, 17 C, BL C,
 FF C,  FF C, FF C, FF C, FF C,
 FF C,  FF C, FF C, FF C, FF C,

 FF C,  FF C, FF C,
 CHAR 7 C,  CHAR 8 C, CHAR 9 C, CHAR - C,
 CHAR 4 C,  CHAR 5 C, CHAR 6 C, CHAR + C,
 CHAR 1 C,  CHAR 2 C, CHAR 3 C,

: EKEY>CHAR ( u -- u false | char true ) \ 94 FACILITY EXT
\    u   -   
\ "".  u  "".
   DUP CTRL_M ALT+ AND IF FALSE   EXIT THEN 
\  DUP  0x1D =  IF FALSE   EXIT THEN    \ CTRL
  DUP  0x2A SHIFT+ =  IF FALSE   EXIT THEN    \ SHIFT

  DUP  0x39 =  IF DROP       BL TRUE     EXIT THEN
  DUP  0x37 =  IF DROP [CHAR] * TRUE     EXIT THEN
  DUP  0x4E =  IF DROP [CHAR] + TRUE     EXIT THEN
  DUP  0x4A =  IF DROP [CHAR] - TRUE     EXIT THEN
  DUP  SHIFT- 0x35 U> IF FALSE           EXIT THEN
  DUP  SHIFT_M AND
  IF   SHIFT-
     DUP 0x02 U< IF DROP  0x1B           ELSE
     DUP 0x0F U< IF 0x02 - SH_1... + C@  ELSE
     DUP 0x1E U< IF 0x0F - SH_Q... + C@  ELSE
     DUP 0x2B U< IF 0x1E - SH_A... + C@  ELSE
                    0x2B - SH_Z... + C@
                  THEN THEN THEN THEN
  ELSE
     DUP  0x2 U< IF DROP  0x1B           ELSE
     DUP 0x0F U< IF  0x2 -    1... + C@  ELSE
     DUP 0x1E U< IF 0x0F -    Q... + C@  ELSE
     DUP 0x2B U< IF 0x1E -    A... + C@  ELSE
                    0x2B -    Z... + C@
                  THEN  THEN THEN THEN
  THEN  TRUE
;

: I_KEY?
\   ,  "".  "".  
\   ,     .
\      KEY.
\    KEY?   "",  
\ KEY?   KEY  EKEY   ""  
\  .
  PENDING-CHAR @ 0 > IF TRUE EXIT THEN
  BEGIN
    EKEY?
  WHILE
    EKEY  EKEY>CHAR
    IF PENDING-CHAR !
       TRUE EXIT
    THEN
    DROP
  REPEAT FALSE
;

: I_KEY ( -- char ) \ 94
\    char.  ,  
\ ,     .
\      . ,   KEY,
\    .
\ ,     ,
\   .
  PENDING-CHAR @ 0 >
  IF PENDING-CHAR @ -1 PENDING-CHAR ! EXIT THEN
  BEGIN
    EKEY  EKEY>CHAR 0=
  WHILE
    DROP
  REPEAT
;


0 VALUE led_status
: SETLEDS
 0xED 0x60 PC!
 BEGIN 0x64 PC@  2 AND 0= UNTIL
  led_status 0x60 PC!
 BEGIN 0x64 PC@  2 AND 0= UNTIL ;


: CONSOLE
  ['] I_KEY? TO KEY?
  ['] I_KEY  TO KEY
  [']  _EMIT TO EMIT ;

400 CONSTANT COM1_ADR
402 CONSTANT COM2_ADR
3F8 VALUE COM-PORT

0 CONSTANT NOPAR   8 CONSTANT ODDPAR  18 CONSTANT EVENPAR \ PARITY CONTROL
0 CONSTANT 1STOP   4 CONSTANT 2STOP                        \ STOP BIT CONTROL
2 CONSTANT 7BIT    3 CONSTANT 8BIT                         \ LENGTH CONTROL

: COM_INIT  ( spid PORT -- )
     TO COM-PORT
   80 COM-PORT 3 + PC!
   1C200 SWAP /  100 /MOD
         COM-PORT 1+  PC!
         COM-PORT     PC!
 8BIT COM-PORT 3 + PC!
    1 COM-PORT 1+ PC!
;

: COM1-INIT
    2580 COM1_ADR W@
     COM_INIT
;

: COM2-INIT
   2580  COM2_ADR W@
     COM_INIT
;

: COM-EMIT?  COM-PORT 5 + PC@ 20 AND  ;

: COM-EMIT BEGIN COM-EMIT? UNTIL COM-PORT PC! ;


: COM-TYPE
  0 ?DO COUNT COM-EMIT LOOP DROP ;

: COM-KEY?  COM-PORT  5 + PC@ 1 AND  ;

: COM-KEY  BEGIN COM-KEY? UNTIL COM-PORT PC@ ;

: IRQ2
  >INT  ." I2="
  INT>
;

: IRQ3
  >INT ." I3=" COM-KEY EMIT
  INT>
;

: IRQ4
  >INT ." I4=" COM-KEY EMIT 
  INT>
;

: I34
 COM1-INIT
 COM2-INIT

 8E00  ['] IRQ2 22 SET_VECTOR
 8E00  ['] IRQ3 23 SET_VECTOR
 8E00  ['] IRQ4 24 SET_VECTOR

   21 PC@  E7 AND 21 PC!
   ENABLE
;

BASE !

: SERIAL
  ['] COM-KEY? TO KEY?
  ['] COM-KEY  TO KEY
  ['] COM-EMIT TO EMIT ;


: SPACE ( -- ) \ 94
\     .
  BL EMIT
;

: SPACES ( n -- ) \ 94
\  n>0 -    n .
  BEGIN
    DUP
  WHILE
    BL EMIT 1-
  REPEAT DROP
;

' I_KEY? >T (TO) KEY?

' I_KEY >T (TO) KEY

