(    "-"
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
    ..
  email:mak@mail.rtc.neva.ru
  http://informer.rtc.neva.ru/fpauk.html
    {812}105-92-03
    {812}552-47-64
)

(     .
  EAX -    
  EBP -   
  ESP -   
  EDI -   [    SPF]
)

HEX

\ ================================================================
\  

Code DUP ;( x -- x x ) \ 94
;  x.
     LEA EBP, [EBP-4]
     mov [ebp],eax
     RET
EndCode

' DUP TO 'DUP_V

Code ?DUP ;( x -- 0 | x x ) \ 94
;  x,   .
     OR  EAX, EAX
     JNZ { ' DUP }
     RET
EndCode

Code 2DUP ;( x1 x2 -- x1 x2 x1 x2 ) \ 94
;    x1 x2.
     LEA EBP, [EBP-8]
     mov [ebp+4],eax
     mov ebx,[ebp+8]
     mov [ebp],ebx
     RET
EndCode

Code DROP ;( x -- ) \ 94
;  x  .
     mov eax,[ebp]
     LEA EBP, [EBP+4]
     RET
EndCode

' DROP TO 'DROP_V

Code MAX ;( n1 n2 -- n3 ) \ 94
; n3 -   n1  n2.
     CMP EAX, [ EBP ]
     JL  { ' DROP }
     LEA EBP, [EBP+4]
     RET
EndCode

Code MIN ;( n1 n2 -- n3 ) \ 94
 ; n3 -   n1  n2.
     CMP EAX, [ EBP ]
     JG  { ' DROP }
     LEA EBP, [EBP+4]
     RET
EndCode

Code UMAX       ;( u1 u2 -- n3 ) \ RETurn the lesser of unsigned u1 and
                                ; unsigned u2
     CMP  EAX, [ EBP ]
     JB { ' DROP }
     LEA EBP, [EBP+4]
     RET
EndCode

Code UMIN       ;( u1 u2 -- n3 ) \ RETurn the lesser of unsigned u1 and
                                ; unsigned u2
     CMP EAX, [ EBP ]
     JA { ' DROP }
     LEA EBP, [EBP+4]
     RET
EndCode

Code 2DROP ;( x1 x2 -- ) \ 94
;      x1 x2.
     MOV     EAX , [EBP+4]
     ADD     EBP , 8
     RET
EndCode

Code SWAP ;( x1 x2 -- x2 x1 ) \ 94
;      
;     XCHG EAX  { EBP }
     MOV   EBX, [ EBP ]
     MOV   [ EBP ],  EAX
     MOV   EAX, EBX
     RET
EndCode

Code BOUNDS ;( x1 x2 -- x1+x2 x1 ) \ OVER + SWAP
     MOV  EBX, [ EBP ]
     ADD  [ EBP ],  EAX
     MOV  EAX, EBX
     RET
EndCode

Code 2SWAP ;( x1 x2 x3 x4 -- x3 x4 x1 x2 ) \ 94
;      .
     MOV ECX, [EBP]
     MOV EBX, [EBP+4]
     MOV EDX, [EBP+8]
     MOV [EBP+8], ECX
     MOV [EBP+4], EAX
     MOV [EBP], EDX
     MOV EAX, EBX
     RET
EndCode

Code OVER ;( x1 x2 -- x1 x2 x1 ) \ 94
;   x1   .
     LEA EBP, [EBP-4]
     MOV  [ EBP ],  EAX
     MOV  EAX, [ EBP + 4 ]
     RET
EndCode


Code TUCK ;( x1 x2 -- x2 x1 x2 ) \ 94
     SUB  EBP,  4
     MOV  EBX, [ EBP + 4 ]
     MOV  [ EBP ],  EBX
     MOV  [ EBP + 4 ],  EAX
     RET
EndCode

Code PICK      ;( ... +n -- ... w ) \ Copy the nth stack item to tos.
      MOV    EAX, [ EBP + EAX*4 ]
      RET
EndCode
\ ROLL !!!!!
Code 2OVER ;( x1 x2 x3 x4 -- x1 x2 x3 x4 x1 x2 ) \ 94
;    x1 x2   .
     LEA EBP, [EBP-08H]
     MOV  [EBP+4],  EAX
     MOV  EBX, [EBP+10H]
     MOV  [EBP],  EBX
     MOV  EAX, [EBP+0CH]
     RET
EndCode


Code NIP ;( x1 x2 -- x2 ) \ 94 CORE EXT
;      .
     ADD EBP,  4
     RET
EndCode

Code ROT ;( x1 x2 x3 -- x2 x3 x1 ) \ 94
;     .
;     XCHG EAX     [ EBP ]
;     XCHG EAX   4  [ EBP ]
     MOV  EDX, [EBP]
     MOV  [EBP], EAX
     MOV  EAX, [EBP+4]
     MOV  [EBP+4], EDX
     RET
EndCode


Code -ROT ;( x1 x2 x3 -- x3 x1 x2 ) ; !!!!!
;  ROT
     MOV  EBX, [ EBP + 4 ]
     MOV  ECX, [ EBP ]
     MOV  [ EBP+4 ],  EAX
     MOV  [ EBP ],  EBX
     MOV   EAX,  ECX
     RET
EndCode

\ ================================================================
\  

0 [IF]
Code >R    \ 94
; : ;( x -- ) ;( R: -- x )
;  x   .
; :      .
     POP EBX
     PUSH EAX
     MOV     EAX , [EBP]
     ADD     EBP , 4
     JMP EBX
EndCode

Code R>    ; 94
; : ;( -- x ) ;( R: x -- )
;  x      .
; :      .
     POP  EBX
     LEA EBP, [EBP-4]
     MOV  [ EBP ],  EAX
     POP  EAX
     JMP  EBX
EndCode
[ELSE]
Code C->R    ; 94
     PUSH EAX
     MOV     EAX , [EBP]
     ADD     EBP , 4
     RET
EndCode

Code C-R>    ; 94
     LEA EBP, [EBP-4]
     MOV  [ EBP ],  EAX
     POP EAX
     RET
EndCode

Code C-RDROP
  ADD ESP, 4
  RET
EndCode

Code DO-UNLOOP
   ADD ESP, { 3 CELLS }
   RET
EndCode


[THEN]

Code 2>R   ; 94 CORE EXT
; :  .
; : ;( x1 x2 -- ) ;( R: -- x1 x2 )
;    x1 x2   . 
;  SWAP >R >R.
     POP   EBX
     PUSH  DWORD PTR [ EBP ]
     PUSH  EAX
     PUSH  EBX
     MOV   EAX , [EBP+4]
     ADD   EBP , 8
     RET
EndCode

Code 2R>  ; 94 CORE EXT
; :  .
; : ;( -- x1 x2 ) ;( R: x1 x2 -- )
;    x1 x2   . 
;  R> R> SWAP.
     LEA EBP, [EBP-8]
     POP EBX
     MOV [ EBP + 4 ], EAX
     POP EAX
     POP DWORD PTR [ EBP ]
     PUSH EBX
     RET
EndCode

Code R@    ; 94
; : ;( -- x ) ;( R: x -- x )
; :     .
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     MOV EAX, [ ESP + 4 ]
     RET
EndCode

Code 2R@  ; 94 CORE EXT
; :  .
; : ;( -- x1 x2 ) ;( R: x1 x2 -- x1 x2 )
;    x1 x2   . 
;  R> R> 2DUP >R >R SWAP.
     LEA EBP, [EBP-8]
     MOV [ EBP + 4 ], EAX
     MOV EAX, [ ESP + { 2 CELLS } ]
     MOV DWORD PTR [ EBP ],  EAX
     MOV  EAX, [ ESP + 4 ]
     RET
EndCode

\ ================================================================
\   

Code @ ;( a-addr -- x ) \ 94
; x -    a-addr.
     MOV EAX, [ EAX ]
     RET
EndCode

Code ! ;( x a-addr -- ) \ 94
;  x   a-addr.
     MOV EBX, [ EBP ]
     MOV DWORD PTR [ EAX ],  EBX
     MOV EAX , [EBP+4]
     ADD EBP , 8
     RET
EndCode

Code C@ ;( c-addr -- char ) \ 94
;     c-addr.     .
     MOVZX EAX, BYTE PTR [ EAX ]
     RET
EndCode

Code C! ;( char c-addr -- ) \ 94
;  char   a-addr.
     MOV EBX, [ EBP ]
     MOV BYTE PTR [ EAX ],  BL
     MOV EAX , [EBP+4]
     ADD EBP , 8
     RET
EndCode

Code W@ ;( c-addr -- word )
;  word   c-addr.     .
     MOVZX   EAX, WORD PTR [ EAX ]
     RET
EndCode

Code W! ;( word c-addr -- )
;  word   a-addr.
     MOV EBX, [ EBP ]
     MOV WORD PTR [ EAX ],  BX
     MOV   EAX , [EBP+4]
     ADD   EBP , 8
     RET
EndCode

Code 2@ ;( a-addr -- x1 x2 ) \ 94
;    x1 x2,    a-addr.
; x2   a-addr, x1   .
;  DUP CELL+ @ SWAP @
     MOV EBX, [ EAX + 4 ]
     LEA EBP, [EBP-4]
     MOV DWORD PTR [ EBP ],  EBX
     MOV EAX,    DWORD PTR [ EAX ]
     RET
EndCode

Code 2! ;( x1 x2 a-addr -- ) \ 94
;    x1 x2   a-addr,
; x2   a-addr, x1   .
;  SWAP OVER ! CELL+ !
     MOV  EBX, [ EBP ]
     MOV  ECX,  DWORD PTR [ EBP + 4 ]
     MOV  DWORD PTR [ EAX ],  EBX
     MOV  DWORD PTR [ EAX +4 ],  ECX
     MOV   EAX , [EBP + { 2 CELLS } ]
     ADD   EBP , 0CH
     RET
EndCode

\ ================================================================
\ 

Code 1+ ;( n1|u1 -- n2|u2 ) \ 94
;  1  n1|u1    u2|n2.
     LEA EAX, [EAX+1]
     RET
EndCode

Code 1- ;( n1|u1 -- n2|u2 ) \ 94
;  1  n1|u1    n2|u2.
     LEA EAX, [EAX-1]
     RET
EndCode

Code 2+ ;( W -> W+2 )
     LEA EAX, [EAX+2]
     RET
EndCode

Code 2- ;( W -> W-2 )
     LEA EAX, [EAX-2]
     RET
EndCode

Code 2* ;( x1 -- x2 ) \ 94
; x2 -   x1    ,  
;    .
;  SHL EAX
;   LEA EAX, [EAX+EAX]
  LEA EAX, [EAX*2]
  RET 
EndCode

Code CELL+ ;( a-addr1 -- a-addr2 ) \ 94
;     a-addr1   a-addr2.
     LEA EAX, [EAX+4]
     RET
EndCode

Code CELL- ;( a-addr1 -- a-addr2 ) \ 94
;     a-addr1   a-addr2.
     LEA EAX, [EAX-4]
     RET
EndCode

Code CELLS ;( n1 -- n2 ) \ 94
; n2 -  n1 .
  LEA     EAX,  DWORD PTR [ EAX *4 ]
  RET 
EndCode


Code + ;( n1|u1 n2|u2 -- n3|u3 ) \ 94
;  n1|u1  n2|u2    n3|u3.
     ADD EAX,  DWORD PTR [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code D+ ;( d1|ud1 d2|ud2 -- d3|ud3 ) \ 94 DOUBLE
;  d1|ud1  d2|ud2    d3|ud3.
       MOV EBX,    DWORD PTR [ EBP ]
       ADD DWORD PTR [ EBP + { 2 CELLS } ],  EBX
       ADC EAX, DWORD PTR [ EBP +4 ]
       LEA EBP, [EBP+8]
       RET
EndCode

Code D- ;( d1 d2 -- d3 ) \ 94 DOUBLE
; perform a double subtract (64bit)
       MOV EBX,   DWORD PTR [ EBP ]
       SUB DWORD PTR [ EBP + { 2 CELLS } ],  EBX
       SBB [ EBP + 4 ], EAX
       MOV EAX, DWORD PTR [ EBP +4 ]
       LEA EBP, [EBP+8]
       RET
EndCode

Code - ;( n1|u1 n2|u2 -- n3|u3 ) \ 94
;  n2|u2  n1|u1    n3|u3.
     NEG EAX
     ADD EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code 1+! ;( A -> )
     INC   DWORD PTR [ EAX ]
     MOV   EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code 0! ;( A -> )
     MOV   DWORD PTR [ EAX ], 0 
     MOV   EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code COUNT ;( c-addr1 -- c-addr2 u ) \ 94
;        c-addr1.
; c-addr2 -     c-addr1.
; u -   c-addr1,    ,
;    c-addr2.
     LEA EBP, [EBP-4]
     LEA  EBX,   DWORD PTR [ EAX +1 ]
     MOV  DWORD PTR [ EBP ],    EBX
     MOVZX EAX,  BYTE PTR [ EAX ]
     RET
EndCode

Code * ;( n1|u1 n2|u2 -- n3|u3 ) \ 94
;  n1|u1  n2|u2    n3|u3.
;     IMUL DWORD PTR [ EBP ] ; !!!!!
     MUL DWORD PTR [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code AND ;( x1 x2 -- x3 ) \ 94
; x3 -  "" x1  x2.
     AND EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code OR ;( x1 x2 -- x3 ) \ 94
; x3 -  "" x1  x2.
     OR EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code XOR ;( x1 x2 -- x3 ) \ 94
; x3 -  " " x1  x2.
     XOR EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code INVERT ;( x1 -- x2 ) \ 94
;    x1     x2.
     NOT EAX
     RET
EndCode

Code NEGATE ;( n1 -- n2 ) \ 94
; n2 -   n1.
     NEG EAX
     RET
EndCode

Code ABS ;( n -- u ) \ 94
; u -   n.
     TEST  EAX, EAX
     JS  { ' NEGATE }
     RET
EndCode

Code DNEGATE ;( d1 -- d2 ) \ 94 DOUBLE
; d2   d1  .
     MOV  EBX, [ EBP ]
     NEG  EAX
     NEG  EBX
     SBB  EAX,   0
     MOV  DWORD PTR [ EBP ],  EBX
     RET
EndCode

Code NOOP ;( -> )
     RET
EndCode

Code S>D ;( n -- d ) \ 94
;   n    d     .
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     CDQ
     MOV  EAX, EDX
     RET
EndCode

Code D>S ;( d -- n ) \ 94 DOUBLE
; n -  d.
;   ,  d   
;   .
     MOV     EAX, [ EBP ]
     ADD     EBP, 4
     RET
EndCode

Code U>D ;( U -> D ) \      
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     XOR  EAX, EAX
     RET
EndCode

Code C>S ;( c -- n )  \  CHAR
     MOVSX  EAX, AL
     RET
EndCode

Code UM* ;( u1 u2 -- ud ) \ 94
; ud -  u1  u2.     .
       MUL  DWORD PTR [ EBP ] 
       MOV  [ EBP ], EAX
       MOV  EAX, EDX
       RET
EndCode

Code / ;( n1 n2 -- n3 ) \ 94
;  n1  n2,   n3.
;   ,  n2  .
;  n1  n2    -    
; .
     MOV  ECX,  EAX
     MOV  EAX, [ EBP ]
     CDQ
     IDIV ECX
     LEA EBP, [EBP+4]
     RET
EndCode

Code U/ ;( W1, W2 -> W3 ) \   W1  W2
     MOV  ECX,  EAX
     MOV  EAX, [ EBP ]
     XOR EDX, EDX
     DIV ECX
     LEA EBP, [EBP+4]
     RET
EndCode

Code +! ;( n|u a-addr -- ) \ 94     \ !!!!!
;  n|u      a-addr.
     MOV EBX, [ EBP ]
     ADD DWORD PTR [ EAX ],  EBX
     MOV EAX,  DWORD PTR [ EBP +4 ]
     LEA EBP, [EBP+8]
     RET
EndCode

Code MOD ;( n1 n2 -- n3 ) \ 94
;  n1  n2,   n3.
;   ,  n2  .
;  n1  n2    -    
; .
     MOV  ECX,  EAX
     MOV  EAX, [ EBP ]
     LEA EBP, [EBP+4]
     CDQ
     IDIV ECX
     MOV  EAX, EDX
     RET
EndCode

Code UMOD ;( W1, W2 -> W3 ) \    W1  W2
     MOV  ECX,  EAX
     MOV EAX, [ EBP ]
     LEA EBP, [EBP+4]
     XOR EDX, EDX
     DIV ECX
     MOV EAX, EDX
     RET
EndCode

Code UM/MOD ;( ud u1 -- u2 u3 ) \ 94
;  ud  u1,   u3   u2.
;     .
;   ,  u1   
;      .
       MOV EBX, EAX
       MOV EDX, [EBP]
       MOV EAX, [EBP+4]
       DIV EBX
       LEA EBP, [EBP+4]
       MOV [EBP], EDX
       RET
EndCode

Code 2/ ;( x1 -- x2 ) \ 94
; x2 -   x1        .
     SAR   EAX,1
     RET
EndCode

Code */MOD ;( n1 n2 n3 -- n4 n5 ) \ 94
;  n1  n2,     d.
;  d  n3,   n4   n5.
     MOV  EBX, EAX
     MOV  EAX, [ EBP ]
     MOV  ECX, [ EBP +4 ]
     IMUL ECX
     IDIV EBX
     MOV  [EBP+4], EDX
     LEA EBP, [EBP+4]
     RET
EndCode

Code M* ;( n1 n2 -- d ) \ 94
; d -    n1  n2.
     IMUL DWORD PTR [EBP]
     MOV  [EBP], EAX
     MOV  EAX,  EDX
     RET
EndCode

Code LSHIFT ;( x1 u -- x2 ) ; 94
;  x1  u  .      ,
;   .
;   ,  u   
;    .
     MOV ECX, EAX
     MOV EAX, [ EBP ]
     SHL EAX, CL
     LEA EBP, [EBP+4]
     RET
EndCode

Code RSHIFT ;( x1 u -- x2 ) \ 94
;  x1  u  .      ,
;   .
;   ,  u   
;    .
     MOV ECX, EAX
     MOV EAX, [ EBP ]
     SHR EAX, CL
     LEA EBP, [EBP+4]
     RET
EndCode

Code SM/REM ;( d1 n1 -- n2 n3 ) \ 94
;  d1  n1,    n3   n2.
;     .
;   ,  n1 ,   
;    .
     MOV EBX, EAX
     MOV EDX, [EBP]
     MOV EAX, [EBP+4]
     IDIV EBX
     LEA EBP, [EBP+4]
     MOV [EBP], EDX
     RET
EndCode

Code FM/MOD ;( d1 n1 -- n2 n3 ) \ 94
;  d1  n1,   n3   n2.
;     .
;   ,  n1 ,   
;    .
     XCHG EBP, ESP
     MOV  EBX, EAX
     POP EDX
     POP EAX
     PUSH EAX
     IDIV EBX
     OR EAX, EAX
     JS SHORT  MM
     SBEGIN
       POP EBX
       PUSH EDX
       XCHG EBP, ESP
       RET
MM:    OR EDX,  EDX
     SUNTIL 0<>
     DEC EAX
     MOV  ECX,  EAX
     IMUL EBX
     POP EBX
     SUB EBX, EAX
     PUSH EBX
     MOV  ECX, EAX
     XCHG EBP, ESP
     RET
EndCode

Code TRUE ;( -- false ) \ 94 CORE EXT
;   "".
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     MOV  EAX,  -1
     RET
EndCode


Code FALSE ;( -- false ) \ 94 CORE EXT
;   "".
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     XOR EAX, EAX
     RET
EndCode

Code DIGIT ;( C, N1 -> N2, TF / FF ) \ N2 -   C 
           ;       N1
     MOV EBX,  [ EBP ]  ; !!!!!
     CMP BL,   30H
     JC  SHORT MM
     CMP BL,   3AH             
     SIF U<
         SUB BL,  30H
         CMP BL,  AL
         JAE SHORT MM
     SELSE
         CMP BL,  41H
         JC  SHORT MM
         SUB BL,  37H
         CMP BL,  AL
         JAE SHORT MM
     STHEN
     MOV [ EBP ],  EBX
     MOV EAX,   -1
     RET
MM:  XOR EAX, EAX
     LEA EBP, [EBP+4]
     RET
EndCode

\ ================================================================
\ 

Code = ;( x1 x2 -- flag ) \ 94
; flag ""    ,  x1   x2.
     XOR  EAX, [ EBP ]
     SUB  EAX, 1
     SBB  EAX, EAX
     LEA EBP, [EBP+4]
     RET
EndCode

Code <> ;( x1 x2 -- flag ) \ 94 CORE EXT
; flag ""    ,  x1   x2.
     XOR  EAX, [ EBP ]
     NEG  EAX
     SBB  EAX,  EAX
     LEA EBP, [EBP+4]
     RET
EndCode

Code < ;( n1 n2 -- flag ) \ 94
; flag ""    ,  n1  n2.
       CMP  [ EBP ], EAX
       SETGE AL
       AND  EAX, 01
       DEC  EAX
       LEA EBP, [EBP+4]
       RET
EndCode

Code > ;( n1 n2 -- flag ) \ 94
; flag ""    ,  n1  n2.
       CMP  EAX, [ EBP ]
       SETGE AL
       AND  EAX, 01
       DEC  EAX
       LEA EBP, [EBP+4]
       RET
EndCode

Code WITHIN     ;( n1 low high -- f1 ) \ f1=true if ((n1 >= low) & (n1 < high))
      MOV  EBX, [ EBP + 4 ]
      SUB  EAX, [ EBP ]
      SUB  EBX, [ EBP ]
      SUB  EBX, EAX
      SBB  EAX, EAX
      ADD  EBP, 8
      RET
EndCode

Code D< ;( d1 d2 -- flag ) \ DOUBLE
; flag ""    ,  d1  d2.
     MOV EBX, [ EBP ]
     CMP DWORD PTR [ EBP +8 ], EBX
     SBB DWORD PTR [ EBP +4 ], EAX
     MOV EAX,  0
     SIF <
       DEC EAX
     STHEN
     ADD EBP,   0CH
     RET
EndCode

Code D> ;( d1 d2 -- flag ) \ DOUBLE
; flag ""    ,  d1  d2.
    MOV EBX, [ EBP ]
    CMP EBX, DWORD PTR [ EBP + 8 ]
    SBB EAX, DWORD PTR [ EBP + 4 ]
    SAR EAX,   1FH
    ADD EBP,   0CH
    RET
EndCode

Code U< ;( u1 u2 -- flag ) \ 94
; flag ""    ,  u1  u2.
    CMP  [ EBP ], EAX
    SBB  EAX, EAX
    ADD  EBP,  04
    RET
EndCode

Code U> ;( u1 u2 -- flag ) \ 94
; flag ""    ,  u1  u2.
    CMP  EAX, [ EBP ]
    SBB  EAX, EAX
    ADD  EBP,   04
    RET
EndCode

Code 0< ;( n -- flag ) \ 94
; flag ""    ,  n  .
    SAR EAX,   1F
    RET
EndCode

Code 0= ;( x -- flag ) \ 94
; flag ""    ,  x  .
     SUB  EAX, 1
     SBB  EAX, EAX 
     RET
EndCode

Code 0<> ;( x -- flag ) \ 94 CORE EXT
; flag ""    ,  x   .
     NEG  EAX
     SBB  EAX, EAX
     RET
EndCode

Code D0= ;( xd -- flag ) \ 94 DOUBLE
; flag ""    ,  xd  .
     OR   EAX, [ EBP ]
     SUB  EAX, 1
     SBB  EAX, EAX 
     LEA EBP, [EBP+4]
     RET
EndCode

Code D2* ;( xd1 -- xd2 ) \ 94 DOUBLE
; xd2 is the result of shifting xd1 one bit toward the most-significant
; bit, filling the vacated least-significant bit with zero     
     SHL DWORD PTR [EBP],  1
     RCL  EAX,   1
     RET
EndCode

Code D2/ ;( xd1 -- xd2 ) \ 94 DOUBLE
; xd2 is the result of shifting xd1 one bit toward the least-significant bit,
; leaving the most-significant bit unchanged
     SAR  EAX,  1
     RCR DWORD PTR [EBP], 1
     RET
EndCode

\ ================================================================
\ 

Code -TRAILING ;( c-addr u1 -- c-addr u2 ) \ 94 STRING
;  u1  , u2  u1,      
;  ,  c-addr  u1.  u1     
;  , u2 .
     PUSH EDI
     MOV  ECX, EAX
     SIF C0<>
       MOV EDI, DWORD PTR [ EBP ]
       ADD EDI, ECX
       DEC EDI 
       MOV AL,  20H
       STD
       REPZ SCASB
       SIF 0<>
          INC ECX 
       STHEN
       CLD
       MOV  EAX, ECX 
     STHEN
     POP EDI
     RET
EndCode

Code COMPARE ;( c-addr1 u1 c-addr2 u2 -- n ) \ 94 STRING !!!!!
;  ,  c-addr1 u1,  ,  c-addr2 u2.
;  ,    ,   ,  
;        .   
; , n .         
; ,  n   (-1),  u1  u2,   (1).
;           ,  n 
;  (-1),     ,  c-addr1 u1
;    ,     ,
;  c-addr2 u2,     .
   PUSH EDI
   MOV  ECX, EAX
   SUB  EAX, EAX
   CMP  ECX, [ EBP +4 ]
   SIF 0<>
      SIF U<
         INC   EAX
      SELSE
         DEC EAX
         MOV ECX, [ EBP +4 ]
      STHEN
   STHEN
   MOV ESI, [ EBP + { 2 CELLS } ]
   MOV EDI, [ EBP ]
   REPE 
   CMPSB
   SIF 0<>
      SIF U>=
         MOV EAX,  1
      SELSE
         MOV EAX, -1
      STHEN
   STHEN
   LEA  EBP, [ EBP + { 3 CELLS } ]
   POP EDI          
   RET
EndCode

Code SEARCH ;( c-addr1 u1 c-addr2 u2 -- c-addr3 u3 flag ) \ 94 STRING
;    ,  c-addr1 u1, ,  c-addr2 u2.
;   "",     c-addr3   u3
; .   "",   ,  c-addr3  c-addr1,
;  u3  u1.        \ !!!!!
      LEA EBP, [EBP-4]
      MOV  [ EBP ], EAX
      PUSH EDI
      CLD
      MOV EBX, DWORD PTR [ EBP ]
      OR  EBX, EBX
      SIF 0<> 
        MOV EDX, DWORD PTR [ EBP + { 2 CELLS } ]
        MOV EDI, DWORD PTR [ EBP + { 3 CELLS } ]
        ADD EDX, EDI
        SBEGIN
           MOV ESI, DWORD PTR [ EBP +4 ]
           LODSB
           MOV ECX, EDX
           SUB ECX, EDI
           JECXZ LLD
           REPNZ
           SCASB
           JNE SHORT LLD   ;        
           CMP EBX,   1
           JZ SHORT LLC   ;     1  
           MOV ECX, EBX
           DEC ECX
           MOV EAX, EDX
           SUB EAX, EDI
           CMP EAX, ECX
           JC SHORT LLD   ;     
           PUSH EDI
           REPZ CMPSB
           POP EDI
        SUNTIL 0=
LLC:    DEC EDI       ;   
        SUB EDX, EDI
        MOV  DWORD PTR [ EBP + { 3 CELLS } ], EDI
        MOV  DWORD PTR [ EBP + { 2 CELLS } ], EDX
      STHEN
      MOV EAX,   -1 
      JMP SHORT LLA
LLD:  XOR EAX, EAX
LLA:  LEA EBP, [EBP+4]
      MOV [ EBP ], EAX
      POP EDI
      MOV EAX, [ EBP ]
      LEA EBP, [EBP+4]
      RET
EndCode

Code CMOVE ;( c-addr1 c-addr2 u -- ) \ 94 STRING
;  u  ,  u    
;     c-addr1  c-addr2,   ,  
;    .
     MOV  EDX, EDI
     MOV  ECX, EAX
     MOV  EDI, DWORD PTR [ EBP ]
     MOV  ESI, DWORD PTR [ EBP +4 ]
     CLD
     REPZ   MOVSB
     LEA EBP, [EBP+0CH]
     MOV EAX, [EBP-4]
     MOV EDI, EDX
     RET
EndCode

Code QCMOVE ;( c-addr1 c-addr2 u -- ) \ 94 STRING
;  u  ,  u     
;     c-addr1  c-addr2,   ,   
;    .
       MOV EDX, EDI
       MOV ECX, EAX
       MOV EDI, [EBP]
       MOV ESI, [EBP+4]
       CLD
       SAR ECX,  2
       REP MOVSD
       MOV ECX, EAX
       AND ECX,  3
       REP MOVSB
       LEA EBP, [EBP+0CH]
       MOV EAX, [EBP-4]
       MOV EDI, EDX
       RET
EndCode

Code CMOVE> ;( c-addr1 c-addr2 u -- ) \ 94 STRING
;  u  ,  u    
;     c-addr1  c-addr2,   ,  
;    .

       MOV EDX, EDI
       MOV ECX, EAX
       MOV EDI, [EBP]
       MOV ESI, [EBP+4]
       STD
       ADD EDI, ECX
       DEC EDI
       ADD ESI, ECX
       DEC ESI
       REP MOVSB
       MOV EDI, EDX
       LEA EBP, [EBP+0CH]
       MOV EAX, [EBP-4]
     RET
EndCode

Code FILL ;( c-addr u char -- ) \ 94  \ !!!!!
;  u  ,  char  u    c-addr.
   MOV EDX, EDI
   MOV ECX, [EBP]
   MOV EDI, [EBP+4]
   CLD
   REP STOSB
   MOV EDI, EDX
   LEA EBP, [EBP+0CH]
   MOV EAX, [EBP-4]
   RET
EndCode

Code ASCIIZ> ;( c-addr -- c-addr u )
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     XOR  EBX, EBX
     SBEGIN
       MOV  BL, BYTE PTR [ EAX ]
       INC  EAX 
       OR   BL,  BL
     SUNTIL 0=
     DEC  EAX
     SUB  EAX, [ EBP ]
     RET
EndCode

\ ================================================================
\  

Code SP! ;( A -> )
;     LEA EBP, [EBP-4]
;     MOV  [ EBP ], EAX
     MOV  EBP, EAX
     MOV  EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code RP! ;( A -> )
     POP EBX
     MOV  ESP, EAX
     PUSH EBX
     MOV EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code SP@ ;( -> A )
     SUB     EBP, 4
     MOV     [ EBP ], EAX
     MOV EAX, EBP
     RET
EndCode

Code RP@ ;( -- RP )
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     LEA  EAX, [ ESP + 4 ]
     RET
EndCode

Code C-RP@ ;( -- RP )
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     MOV  EAX,  ESP 
     RET
EndCode

\ ================================================================
\ 

Code 0 ;( -> 0 )
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     XOR EAX, EAX
     RET
EndCode

\ ================================================================
\   (   )

Code EXECUTE ;( i*x xt -- j*x ) \ 94
;  xt       .
;      ,  .
     MOV EBX, EAX
     MOV EAX, [ EBP ]
     LEA EBP, [EBP+4]
     JMP EBX
EndCode

Code @EXECUTE ;( i*x xt -- j*x ) \ 94
;  xt       .
;      ,  .
     MOV EBX, EAX
     MOV EAX, [ EBP ]
     LEA EBP, [EBP+4]
     JMP DWORD PTR [ EBX ]
EndCode

\ ================================================================
\   (  )

Code TlsIndex! ;( x -- ) \    
     MOV  EDI, EAX
     MOV  EAX, [ EBP ]
     LEA EBP, [EBP+4]
     RET
EndCode

Code TlsIndex@ ;( -- x )
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     MOV  EAX, EDI
     RET
EndCode

Code FS@ ;( addr -- x )
     MOV EAX, DWORD PTR FS: [ EAX ]
     RET
EndCode

Code FS! ;( x addr -- )
     MOV  EBX, DWORD PTR  [ EBP ]
     MOV DWORD PTR FS: [ EAX ], EBX
     MOV  EAX, DWORD PTR [ EBP +4 ]
     ADD  EBP, 8
     RET
EndCode

\ VARIABLE DP_SAVE
VARIABLE  DP      \ ,  HERE  

Code HERE ;( -- addr ) \ 94
; addr -   .
     LEA EBP, [EBP-4]
     MOV  [ EBP ], EAX
     MOV  EAX, DWORD PTR [ { ' DP >BODY >T } ]
     RET
EndCode

Code ALLOT ;( n -- ) \ 94
;  n  ,  n   .  n 
;  -  |n|   .  n , 
;    .
;    ALLOT      n
;   ,      ALLOT.
;    ALLOT     
;    n   ,    
;     ALLOT.
  ADD   DWORD PTR  [ { ' DP >BODY >T } ], EAX
  MOV   EAX, [ EBP ]
  LEA EBP, [EBP+4]
  RET
  EndCode

Code C, ;( char -- ) \ 94
;           char.
  MOV  EBX, DWORD PTR  [ { ' DP >BODY >T } ]
  MOV  BYTE PTR  [ EBX ],  AL
  INC  DWORD PTR [ { ' DP >BODY >T } ]
  MOV  EAX, [ EBP ]
  LEA EBP, [EBP+4]
  RET
EndCode

Code W, ;( char -- ) \ 94
;    word       char.
  MOV  EBX, DWORD PTR [ { ' DP >BODY >T } ]
  MOV  WORD PTR [ EBX ],  AX
  ADD  DWORD PTR [ { ' DP >BODY >T } ], 2
  MOV  EAX, [ EBP ]
  LEA EBP, [EBP+4]
  RET
EndCode

Code , ;( x -- ) \ 94
;         x   .
  MOV EBX, DWORD PTR [ { ' DP >BODY >T } ]
  MOV DWORD PTR [ EBX ],  EAX
  ADD DWORD PTR [ { ' DP >BODY >T } ], 4
  MOV EAX, [ EBP ]
  LEA EBP, [EBP+4]
  RET
EndCode

Code J   ; 94
; :  .
; : ;( -- n|u ) ( R: loop-sys -- loop-sys )
; n|u -     .
;   ,   .
     LEA EBP, [EBP-4]
     MOV [ EBP ], EAX
     MOV EAX, DWORD PTR [ ESP + { 4 CELLS } ]
     SUB EAX, DWORD PTR [ ESP + { 5 CELLS } ]
     RET
EndCode

( inline'    )

Code C-DO
      MOV  EBX,  80000000H
      SUB  EBX, [EBP-8]
      PUSH EBX
      ADD  EBX, EAX
      PUSH EBX
      MOV  EAX, [EBP-4]
      RET
EndCode

Code C-?DO
      CMP  EAX, [EBP-8]
      SIF  0=
        MOV  EAX, [EBP-4]
        JMP  EBX
      STHEN
      PUSH EBX
      MOV     EBX , 80000000
      SUB  EBX, [EBP-8]
      PUSH EBX  ; 80000000h-to
      ADD  EBX, EAX
      PUSH EBX  ; 80000000H-to+from
      MOV  EAX, [EBP-4]
      RET
EndCode

Code C-I
   LEA EBP, [EBP-4]
   MOV  [EBP], EAX
   MOV  EAX, DWORD PTR [ESP]
   SUB  EAX, [ESP+4]
   RET
EndCode

DECIMAL

