(   "-"    .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
    ..
  email:mak@mail.rtc.neva.ru
  http://informer.rtc.neva.ru/
    {812}105-92-03
    {812}552-47-64
)

: */ ( n1 n2 n3 -- n4 ) \ 94
\  n1  n2,     d.
\  d  n3,   n4.
  */MOD NIP
;

: /MOD ( n1 n2 -- n3 n4 ) \ 94
\  n1  n2,   n3   n4.
\   ,  n2 .
  2DUP / >R MOD R> ;

: D= ( D1 D2  -- FLAG )
       D- D0= ;

: CHAR+ ( c-addr1 -- c-addr2 ) \ 94
\     c-addr1   c-addr2.
  1+
;
: CHARS ( n1 -- n2 ) \ 94
\ n2 -  n1 .
; IMMEDIATE

: MOVE ( addr1 addr2 u -- ) \ 94
\  u  ,   u   addr1  addr2.
\  MOVE  u    addr2     ,
\    u    addr1  .
  >R 2DUP SWAP R@ + U< \       
  IF 2DUP U<           \   
     IF R> CMOVE> ELSE R> CMOVE THEN
  ELSE R> CMOVE THEN
;
: ERASE ( addr u -- ) \ 94 CORE EXT
\  u  ,      u  ,
\    addr.
  0 FILL
;

0x20 VALUE BL ( -- char ) \ 94
\ char -   "".

: BLANK ( addr len -- )     \ fill addr for len with spaces (blanks)
  BL FILL ;

: DABS ( d -- ud ) \ 94 DOUBLE
\ ud   d.
  DUP 0< IF DNEGATE THEN
;

255 CONSTANT MAXCOUNTED   \ maximum length of contents of a counted string

\ : 0X BASE @ HEX >R BL WORD ?LITERAL
\      R> BASE ! ; IMMEDIATE
: "CLIP"        ( a1 n1 -- a1 n1' )   \ clip a string to between 0 and MAXCOUNTED
                MAXCOUNTED MIN 0 MAX ;

: PLACE         ( addr len dest -- )
                SWAP "CLIP" SWAP
                2DUP 2>R
                CHAR+ SWAP MOVE
                2R> C! ;

: +PLACE        ( addr len dest -- ) \ append string addr,len to counted
                                     \ string dest
                >R "CLIP" MAXCOUNTED  R@ C@ -  MIN R>
                                        \ clip total to MAXCOUNTED string
                2DUP 2>R

                COUNT CHARS + SWAP MOVE
                2R> +! ;

: C+PLACE       ( c1 a1 -- )    \ append char c1 to the counted string at a1
                DUP 1+! COUNT + 1- C! ;

FALSE TO ?C-JMP

: |DROP 
  R> RP@ + RP! ;

' |DROP >T TO '|DROP

TRUE TO ?C-JMP

1 CELLS CONSTANT CELL

: LSCAN ( adr len long -- adr' len' )
\ Scan for char through addr for len, returning addr' and len' of char.
        >R 2DUP CELLS R> -ROT   \ adr len long adr len
        OVER + SWAP       \ adr len long adr+len adr
        ?DO DUP I @ =
                IF LEAVE
                ELSE >R 1- >R CELL+ R> R>
                THEN CELL
       +LOOP DROP ;

0  VALUE  DOES-CODE
