(  USER-.
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
   1999
)

VARIABLE MAINX
TC-USER-HERE ' USER-OFFS >BODY !

VECT <FLOAT-INIT>
' NOOP >T (TO) <FLOAT-INIT>

: USER-INIT
  SP@ S0 !
  RP@ R0 !
\   CR OK.1 \ ." XX"  I_KEY DROP
  DECIMAL
  ATIB TO TIB
  0 TO SOURCE-ID
  S-O TO CONTEXT FORTH DEFINITIONS
  ['] NOOP       TO <PRE>
  ['] FIND1      TO FIND
  ['] ?LITERAL2  TO ?LITERAL
  ['] ?SLITERAL2 TO ?SLITERAL
  ['] OK.1       TO OK.
  ['] ERROR0     TO ERROR
  ['] (ABORT1")  TO (ABORT")
  [COMPILE] [
  HANDLER 0!
  CURSTR 0!
  CURFILE 0!
  TRUE WARNING !
  0x10 ALIGN-BYTES !
  <FLOAT-INIT>
\  DROP DUP
;

' USER-INIT >T (TO) FORTH-INSTANCE>
' USER-EXIT >T (TO) <FORTH-INSTANCE
' MAIN1     >T (TO) <MAIN>
' NOOP      >T ' UPPER_V >BODY !

FALSE (TO) ?C-JMP

: TITLE
  ." FORTH-OS" CR
  ." M.Maksimov  http://informer.rtc.neva.ru/  http://www.chat.ru/~mak"  CR 
  ." SPF IS  ANS FORTH" CR
  ." A.Cherezov  http://www.forth.org.ru/" CR
;


' TITLE >T ' MAINX >BODY !

BASE @ HEX

: KBD_HND  >INT

 KB_DATA PC@

  DUP  0x38 =  IF KB_ATR @ ALT+ KB_ATR !  ELSE
  DUP  0xB8 =  IF KB_ATR @ ALT- KB_ATR !  ELSE

  DUP  0x1D =  IF KB_ATR @ CTRL+ KB_ATR !  ELSE
  DUP  0x9D =  IF KB_ATR @ CTRL- KB_ATR !  ELSE
  ID_E0 @ 0=
  IF
  DUP  0x36 =  IF KB_ATR @ SHIFT+ KB_ATR !  ELSE
  DUP  0x2A =  IF KB_ATR @ SHIFT+ KB_ATR !  ELSE
  DUP  0xAA =  IF KB_ATR @ SHIFT- KB_ATR !  ELSE
  DUP  0xB6 =  IF KB_ATR @ SHIFT- KB_ATR !  ELSE
               THEN THEN THEN THEN
  THEN
               THEN THEN  THEN THEN  
  DUP  0xE0 =  ID_E0 !
  KB_ATR @ OR
  DUP  0x53 ALT+ CTRL+ =
               IF BEGIN 0x64 PC@ 2 AND 0=
                  UNTIL 0xFE 0x64 PC!
                 [ 0xFA ( cli ) C, 0xF4 ( hlt ) C, ]
               THEN

  DUP  0x46 CTRL+ =  IF ['] ABORT RP@ 8 CELLS +  !  THEN  \ CTRL BREAK

 KBD-PUT INT> ;

: KBD_INIT
 0x8E00 ['] KBD_HND 0x21 SET_VECTOR
 0x21 PC@ 2 INVERT AND 0x21 PC!
 SETLEDS
;

: .INT  >INT ." INT"  INT> ;

: ."INT" ." INT" ;

: IIII
 0x100 0
 DO  0x8E00
     HERE
    0x60 C,   \ PUSHA
    ['] ."INT" COMPILE,
       I LIT,
    [']  H. COMPILE,

 0xB0 C, 0x20 C,  \ mov al, 0x20
 0xE6 C, 0x20 C,  \ out 20, al
 0x61 C,          \ POPA
 0xCF C,          \ RETI

       I SET_VECTOR
 LOOP ;

\ Startup
\    :

CREATE idtr 0x800 W, IDT_ADDRESS ,

: NOOP-INT  >INT  INT> ;

Code 1INT
   INT 1
   RET
EndCode

: INIT
\  TRUE  0x21 PC!
  0x200  ATTRIB ! \  PAGE
  (HARD-AT-XY?) 2*  2CURSOR !
  HERE   DUP TlsIndex!
  USER-OFFS @ + 1024 + DP ! 
  USER-INIT
  MAINX @ ?DUP IF EXECUTE THEN

  HERE TO KBDBUF KBDBUF-SIZE ALLOT
  KBDBUFIN 0! KBDBUFOUT 0!
\  8259 initialization

    0x11 0x20 PC! \ ICW1
    0x11 0xA0 PC!

    0x20 0x21 PC! \ ICW2: route IRQs 0...7 to INTs 20h...27h
    0x28 0xA1 PC! \ ...IRQs 8...15 to INTs 28h...2Fh

    0x04 0x21 PC! \ ICW3
    0x02 0xA1 PC!

    0x01 0x21 PC! \ ICW4
    0x01 0xA1 PC!

  IIII
 [ 0x0F C, 01 C, 0x1D C, ' idtr >BODY >T , ] \  lidt    [idtr]

  0xFB 0x21 PC!  \ disable all IRQs except cascade (IRQ 2)
  0xFF 0xA1 PC!
  0x8E00  ['] NOOP-INT 0x27 SET_VECTOR
  KBD_INIT
  ENABLE
  BEGIN
    ['] INTERPRET_ &INTERPRET !
    ['] QUIT CATCH (   )
    ?DUP  IF  ERROR THEN
    S0 @ SP! R0 @ RP!
  AGAIN
;
BASE !
\S


