(    .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999 [  USER- 
   CODE-  ]
)

USER     HLD  \  -   ,   PAD

USER     BASE ( -- a-addr ) \ 94
\ a-addr -  ,      (2..36).

1024 TC-USER-ALLOT
USER-CREATE PAD ( -- c-addr ) \ 94 CORE EXT
\ c-addr -      .
1024 TC-USER-ALLOT

: HEX ( -- ) \ 94 CORE EXT
\   BASE  .
  0x10 BASE !
;
: DECIMAL ( -- ) \ 94
\      .
  0xA BASE !
;

: HOLD ( char -- ) \ 94
\  char     .
\   ,   HOLD
\  <#  #>,   .
  HLD @ 1- DUP HLD ! C!
;

: <# ( -- ) \ 94
\    .
  PAD HLD !
;

: # ( ud1 -- ud2 ) \ 94
\  ud1   BASE      
\       ,
\   ud2.
\   ,   #
\  <#  #>,   .
    0 BASE @ UM/MOD >R BASE @ UM/MOD >R
   DUP   0xA < 
        IF   [CHAR] 0       +
        ELSE [CHAR] A 0xA - + 
        THEN 
   HOLD R> R>
;

: #S ( ud1 -- ud2 ) \ 94
\   D1   #   .
\ ud2 - .
\   ,   #S
\  <#  #>,   .
  BEGIN
    # 2DUP D0=
  UNTIL
;

: #> ( xd -- c-addr u ) \ 94
\  xd.       
\  ,  c-addr  u.
\       .
  2DROP HLD @ PAD OVER -
;

: SIGN ( n -- ) \ 94
\  n ,     
\  .
\   ,   SIGN
\  <#  #>,   .
  0< IF [CHAR] - HOLD THEN
;

: D. ( d -- ) \ 94 DOUBLE
\  d     .
  DUP>R DABS <# #S R> SIGN #>
  TYPE SPACE
;

: . ( n -- ) \ 94
\  n   .
  S>D D.
;

: U. ( u -- ) \ 94
\  u   .
  U>D D. ;

: H. ( u -- ) \ 94
  BASE @ SWAP HEX U. BASE ! ;

: .0
  >R 0 <# #S #> R> OVER - 0 MAX DUP
    IF 0 DO [CHAR] 0 EMIT LOOP
    ELSE DROP THEN TYPE
;

: >PRT
  DUP BL U< IF DROP [CHAR] . THEN
;

: PTYPE
  0 DO DUP C@ >PRT EMIT 1+ LOOP DROP
;

: DUMP ( addr u -- ) \ 94 TOOLS
  DUP 0= IF 2DROP EXIT THEN
  15 + 16 U/ 0 DO
    CR BASE @ SWAP 16 BASE ! DUP 4 .0 SPACE
    SPACE DUP 16 0
      DO I 4 MOD 0= IF SPACE THEN
        DUP C@ 2 .0 SPACE 1+
      LOOP SWAP 16  PTYPE
  SWAP BASE ! LOOP DROP
;

: (.") ( T -> )
  COUNT TYPE
;
' (.") TO (.")-CODE

: >NUMBER ( ud1 c-addr1 u1 -- ud2 c-addr2 u2 ) \ 94
\ ud2 -    ,  c-addr1 u1,
\  ,    BASE,     ud1 
\  ud1    BASE.   
\     ,   "+"  "-",
\     .
\ c-addr2 -       
\   ,     .
\ u2 -     .
\   ,  ud2   
\ .
  BEGIN
    DUP
  WHILE
    >R
    DUP>R
    C@ BASE @ DIGIT 0=     \ ud n flag
    IF R> R> EXIT THEN     \ ud n  ( ud = udh udl )
    SWAP BASE @ UM* DROP   \ udl n udh*base
    ROT BASE @ UM* D+      \ (n udh*base)+(udl*baseD)
    R> 1+ R> 1-
  REPEAT
;
